

//==========================================================================================
//Update events
//==========================================================================================

void LAi_Character_FrameUpdate()
{
	float dltTime = GetEventData();
	//  
	LAi_AllCharactersUpdate(dltTime);
	//  
	LAi_QuestDelayProcess(dltTime);
}

//MAXIMUS -->
void LAi_CharacterTypeUpdate()
{
	//
	string chID = GetEventData();
	aref chr = CharacterFromID(chID);
	if(!CheckAttribute(chr,"chr_ai.type")) return;
	float dltTime = 0.0;
	//  
	string func = chr.chr_ai.type;
	if(func != "")
	{
		func = "LAi_type_" + func + "_CharacterUpdate";
		call func(chr, dltTime);
	}
	//  
	func = chr.chr_ai.tmpl;
	if(func == "") return;
	func = "LAi_tmpl_" + func + "_CharacterUpdate";
	call func(chr, dltTime);
	DelEventHandler("CharacterTypeUpdate", "LAi_CharacterTypeUpdate");
}
//MAXIMUS <--

void LAi_CharacterUpdate()
{
	//
	aref chr = GetEventData();
	float dltTime = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterUpdate") == false) return;
	//  
	string func = chr.chr_ai.type;
	if(func != "")
	{
		func = "LAi_type_" + func + "_CharacterUpdate";
		call func(chr, dltTime);
	}
	//  
	func = chr.chr_ai.tmpl;
	if(func == "") return;
	func = "LAi_tmpl_" + func + "_CharacterUpdate";
	call func(chr, dltTime);
}

//==========================================================================================
//EndTask events
//==========================================================================================

void LAi_CharacterEndTask()
{
	//
	string endTask = GetEventData();
	aref chr = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterEndTask") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//  
	bool isProcessed = false;
	switch(endTask)
	{
	case "Goto point":
		func = "LAi_tmpl_" + func + "_EndGoToPoint";
		isProcessed = true;
		break;
	case "Runto point":
		func = "LAi_tmpl_" + func + "_EndRunToPoint";
		isProcessed = true;
		break;
	case "Escape":
		func = "LAi_tmpl_" + func + "_EndEscape";
		isProcessed = true;
		break;
	}
	if(isProcessed != false)
	{
		call func(chr);
	}else{
		Trace("LAi_CharacterEndTask -> unknow end task <" + endTask + ">");
	}
}

//==========================================================================================
//TaskFailure events
//==========================================================================================

void LAi_CharacterTaskFailure()
{
	//
	string endTask = GetEventData();
	aref chr = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterTaskFailure") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//  
	bool isProcessed = false;
	switch(endTask)
	{
	case "Goto point":
		func = "LAi_tmpl_" + func + "_FailureGoToPoint";
		isProcessed = true;
		break;
	case "Runto point":
		func = "LAi_tmpl_" + func + "_FailureRunToPoint";
		isProcessed = true;
		break;
	case "Follow character":
		func = "LAi_tmpl_" + func + "_FailureFollow";
		isProcessed = true;
		break;
	case "Fight":
		func = "LAi_tmpl_" + func + "_FailureFight";
		isProcessed = true;
		break;
	case "Escape":
		func = "LAi_tmpl_" + func + "_FailureEscape";
		isProcessed = true;
		break;
	}
	if(isProcessed != false)
	{
		call func(chr);
	}else{
		Trace("LAi_CharacterTaskFailure -> unknow failure task <" + endTask + ">");
	}
}

void LAi_CharacterBusyPos()
{
	//
	aref chr = GetEventData();
	float x = GetEventData();
	float y = GetEventData();
	float z = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterTaskFailure") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	func = "LAi_tmpl_" + func + "_BusyPos";
	call func(chr, x, y, z);
}


//==========================================================================================
//Follow character's events
//==========================================================================================

void LAi_CharacterFollowGo()
{
	//
	string endTask = GetEventData();
	aref chr = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterFollowGo") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//
	func = "LAi_tmpl_" + func + "_FollowGo";
	call func(chr);
}

void LAi_CharacterFollowStay()
{
	//
	string endTask = GetEventData();
	aref chr = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterFollowStay") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//
	func = "LAi_tmpl_" + func + "_FollowStay";
	call func(chr);
}

//==========================================================================================
//Fight character's events
//==========================================================================================

void LAi_CharacterFightGo()
{
	//
	string endTask = GetEventData();
	aref chr = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterFightGo") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//
	func = "LAi_tmpl_" + func + "_FightGo";
	call func(chr);
}

void LAi_CharacterFightStay()
{
	//
	string endTask = GetEventData();
	aref chr = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterFightStay") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//
	func = "LAi_tmpl_" + func + "_FightStay";
	call func(chr);
}

void LAi_CharacterAttack()
{
	//int tmpLangFileID = LanguageOpenFile("interface_strings.txt");
	aref attack = GetEventData();
	aref enemy = GetEventData();
	float attackDmg = GetEventData();
	float hitDmg = GetEventData();

	// end of unchanged original code

	bool CheckHostile = true; // run LAi_Attacked etc. set-hostile code. NK 05-07-10
	bool SetHostile = true;
	string effects_to_play = "always"; // for selective playing of FX
	int i;
	ref mainCh = GetMainCharacter();//MAXIMUS
	bool bPlayer = false;//MAXIMUS

	//skillearning(attack, "Fencing", 1);	// ccc skillearning

	// ccc special weapon assembly kit start
	// note: the function we are in here runs if a character (referred to as "attack") uses a blade on a targetcharacter ("enemy")
	if(CheckAttribute(attack, "equip.blade")) // NK just in case.
	{
		string weaponID = GetCharacterEquipByGroup(attack,BLADE_ITEM_TYPE); // defines weaponname
		aref weapon;
		Items_FindItem(weaponID, &weapon);	// defines object for weaponattributes

		if( CheckAttribute(weapon, "sound" ) )
		{
			PlaySound( weapon.sound ); 				//JRH
			//LAi_CharacterPlaySound(attack, weapon.sound ); 	//didn't accept stereo sounds
			// plays soundfile if defined in items\itemsinit.c
		}

	// move FX to bottom. NK 05-07-10

// NK move hardcoded chances to the weapon attribute. 05-07-10

		// NK add check so only works for pchar and only works on person who is not pchar's group. 05-07-06
		if( CheckAttribute(weapon, "steal" ) && sti(attack.index) == GetMainCharacterIndex() && !LAi_IsFightMode(enemy) && attack.chr_ai.group != enemy.chr_ai.group)
		 	// if weapon is a thief's tool; works only if victim is not prepared for fight
		{
			CheckHostile = false; // NK for stealth check below
			//skillearning(attack, "sneak", 1);	// ccc skillearning

			LAi_AttemptSteal(attack, enemy, weapon); // NK do this in one function. 05-07-10
		}
		if( CheckAttribute(weapon, "stun" ) && !LAi_IsFightMode(enemy) && enemy.chr_ai.group != LAI_GROUP_PLAYER )
		// if weapon stuns victim; works only if victim is not prepared for fight and no playerassociate
		{
			//skillearning(attack, "sneak", 1);	// ccc skillearning
			if(frnd() < stf(weapon.stun)*GetAttackLuckMod(&attack))	// jun 05 stun doesnt work always anymore
			{
				int duration = 100;
				if(CheckAttribute(weapon, "stun.duration")) duration = sti(weapon.stun.duration);
				//MAXIMUS: during fight, character can join to his crew. Sometimes it may be helpful -->
				bPlayer = false;
				if(CheckAttribute(enemy, "chr_ai.group") && enemy.chr_ai.group==LAI_GROUP_PLAYER)
				{
					if(sti(mainCh.skill.Leadership)>sti(enemy.skill.Leadership)) bPlayer = true;
				}
				else
				{
					if(sti(mainCh.skill.Leadership)<sti(enemy.skill.Leadership)) bPlayer = true;
				}
				LAi_Stunned_StunCharacter(enemy, duration, true, STUN_STARS, bPlayer);
				//MAXIMUS: during fight, character can join to his crew. Sometimes it may be helpful <--
				//effects_to_play += " stun";
			}
		}

		if( CheckAttribute(weapon, "poison" ) ) 	// if weapon poisonous
		{
			Log_SetStringToLog(TranslateString("","Victim poisoned!"));
			enemy.chr_ai.poison =  300 ;		// initial targetchr poisoned
			LAi_CharacterPlaySound(enemy, "OBJECTS\Voices\dead\male\dead4.wav");
			effects_to_play += " poison";
		}
		// NK fix for stealing weapons 05-07-06
		// 05-07-10 reorder this, do actual hostile-setting at bottom.
		if(CheckHostile)
		{
			if(CheckAttribute(weapon, "stealth"))	// silent weapons don't alarm the victim, for others next line runs
			{
		          	if(frnd() < stf(weapon.stealth)*GetAttackLuckMod(&attack)) { SetHostile = false; }
				else { LAi_CharacterPlaySound(enemy,"VOICE\" + LanguageGetLanguage() + "\Eng_m_a_067.wav"); } // sound alarm
			}
		}
		else SetHostile = false;

		if( CheckAttribute(weapon, "throw" ) )	// for onetime use
		{
			if(GetCharacterItem(attack, weaponID) <= 1) RemoveCharacterEquip(attack, weapon.groupID);	// unequips thrown weapon
	              TakeItemFromCharacter(attack, weaponID );		// deletes thrown weapon from inventory
		}


		if( CheckAttribute(weapon, "fist" ) && !LAi_IsImmortal(enemy))
		// PB: New weapons attribute, exclusively for your fists
		//     Can't knock out immortal characters, nor can you do damage to them
		{
			int rank = makeint(attack.rank);
			// Baste -->
		//	int punch = rand(rank) + rank; // PB: Orig code
			float damage = rand(rank)*0.5;
			float kDmg = 1.0;
			if(IsCharacterPerkOn(enemy, "BasicDefense")) kDmg = 0.9;
			if(IsCharacterPerkOn(enemy, "AdvancedDefense")) kDmg = 0.8;
			if(IsCharacterPerkOn(enemy, "SwordplayProfessional")) kDmg = 0.7;
			damage = damage*kDmg;
			if(makeint(damage) <= 0) damage = 1;
			float critical = 0.0;
			if(rand(100) <= 5) critical = damage*2.0;
			bool noExp = false;
			if(CheckAttribute(attack, "chr_ai.group"))
			{
				if(CheckAttribute(enemy, "chr_ai.group"))
				{
					if(attack.chr_ai.group == enemy.chr_ai.group && !CheckAttribute(GetMainCharacter(),"TrainingFight") && !HasSubStr(attack.id,"TrainingFight_") && !HasSubStr(enemy.id,"TrainingFight_"))//MAXIMUS
					{
					// ccc mar05 REPLOSS tweak added
					//	PB: I don't think we need this; no harm done = no reploss needed
					//	LAi_ChangeReputation(attack, - REPLOSS);	// ccc rephit for attacking friends
					//	if(sti(attack.index) == GetMainCharacterIndex()) traceandlog("CHANGE REP for player: " + -REPLOSS + " - attacking friends");	// LDH 19Dec08
						damage = 0.0;
						critical = 0.0;
						noExp = true;
					}
				}
			}
			if(critical > 0.0)
			{
				if(sti(attack.index) == GetMainCharacterIndex())
				{
					Log_SetStringToLog(XI_ConvertString("Critical Hit"));
				}
			}
			// Calculates the strength of your punch; character's rank increases damage

			//LAi_ApplyCharacterDamage(enemy, punch);
			if(critical > 0.0)
			{
				LAi_ApplyCharacterDamage(enemy, MakeInt(ApplyArmor(enemy, attack, critical, true) + 0.5)); // GreatZen-NK
			}
			else
			{
				LAi_ApplyCharacterDamage(enemy, MakeInt(ApplyArmor(enemy, attack, damage, true) + 0.5)); // GreatZen-NK
			}
			if(critical > 0.0) damage = critical; // For stun check below and EXP calculation
			// Applies damage to enemy
			PlaySound("OBJECTS\duel\punch"+sti(Rand(2)+1)+".wav");
			// Play a random punch impact sound

			LAi_CheckKillCharacter(enemy); // Checks if this has killed the character

			if(!LAi_IsDead(enemy)) //checks if char now dead or not
			{
			//	if(rand(100) < punch + sti(attack.skill.Sneak) && sti(enemy.index) != GetMainCharacterIndex()) // PB: Orig code
				if(rand(50) < damage && sti(enemy.index) != GetMainCharacterIndex()) // Baste
				// Checks if punch knocks enemy out; character's rank increases chance
				{	//MAXIMUS: during fight, character can join to his crew. Sometimes it may be helpful -->
					bPlayer = false;
					if(CheckAttribute(enemy, "chr_ai.group") && enemy.chr_ai.group==LAI_GROUP_PLAYER)
					{
						if(sti(GetCharacterSkill(mainCh,SKILL_LEADERSHIP)) > sti(GetCharacterSkill(enemy,SKILL_LEADERSHIP))) bPlayer = true;
					}
					/*else
					{
						if(sti(GetCharacterSkill(mainCh,SKILL_LEADERSHIP)) < sti(GetCharacterSkill(enemy,SKILL_LEADERSHIP))) bPlayer = true;
					}*/
					LAi_Stunned_StunCharacter(enemy, 100, true, STUN_STARS, bPlayer);
					//MAXIMUS: during fight, character can join to his crew. Sometimes it may be helpful <--
					SetHostile = false;
				}
			}
		}
		bool isSetBalde = (SendMessage(enemy, "ls", MSG_CHARACTER_EX_MSG, "IsSetBalde") != 0);
		int erank = makeint(enemy.rank);
		float exp = damage*((1.0 + erank*0.5)/(1.0 + rank*0.5)) * sqrt(erank);
		if(!isSetBalde)
		{
			// ccc mar05 REPLOSS tweak added
			if(enemy.chr_ai.group != LAi_monsters_group)
			{
				if(sti(attack.index) == GetMainCharacterIndex()) traceandlog("CHANGE REP for player: " + -REPLOSS + " - undrawn blade 2"); 	// LDH 19Dec08
				LAi_ChangeReputation(attack, - REPLOSS); // NK tempfix for un-drawn blades 04-17
			}
			exp = 0.0;
		}

		if(!noExp)
		{
			AddCharacterExp(attack, MakeInt(exp*0.5 + 0.5));
		}
		// Baste <--

		if( CheckAttribute(weapon, "pistolclub" ))
		// JRH: New weapons attribute, exclusively for your pistolclub
		{
			int rankk = makeint(attack.rank);
			int club = rand(rankk) + rankk + 5;		//testing how much better this should be than fists
			// Calculates the strength of your club; character's rank increases damage

			LAi_ApplyCharacterDamage(enemy, club);
			// Applies damage to enemy

			switch(rand(2))
			{
				case 0: PlaySound("OBJECTS\duel\club1.wav"); break;
				case 1: PlaySound("OBJECTS\duel\club2.wav"); break;
				case 2: PlaySound("OBJECTS\duel\club3.wav"); break;
			}
			// Play a random club impact sound

			LAi_CheckKillCharacter(enemy); // Checks if this has killed the character

			//skip stunned??? - think it's strange: enemy just standing there - or causes other strange situations
			if(!LAi_IsDead(enemy)) //checks if char now dead or not
			{
				if(rand(100) < club + sti(attack.skill.Sneak) && sti(enemy.index) != GetMainCharacterIndex())
				// Checks if club knocks enemy out; character's rank increases chance
				{
					//LAi_Stunned_StunCharacter(enemy, 100, true, STUN_STARS, false);
					//SetHostile = false;

					float u, v, w;
					GetCharacterPos(enemy, &u, &v, &w);
					CreateParticleSystem("stars" , u, v+1, w, 0.0, 0.0, 0.0, sti(20) );
					LAi_SetStunnedType(enemy);
					//sitting now
				}
			}
		}

		// CCC and PB: New attribute to weapons to allow for disarming opponents
		bool tbool = CheckAttribute(enemy, "equip.blade");
		if(tbool) tbool = GetCharacterEquipByGroup(enemy,BLADE_ITEM_TYPE) != "bladeX4";
		if( DISARM_MODE && CheckAttribute(weapon, "disarm" ) &&  LAi_IsFightMode(enemy) && !CheckAttribute(enemy, "nodisarm" ) && tbool)
		{
			int disarmbonus = 0;
			if(CheckAttribute(attack,"perks.list.SwordplayProfessional")) {disarmbonus = 20;}
			// if attacker has professional fencing skill, increase disarm chance with 20%

			int disarmpenalty = 0;
			if(CheckAttribute(enemy,"perks.list.SwordplayProfessional")) {disarmpenalty = 10;}
			// if attacked victim has professional fencing skill, decrease disarm chance with 10%

			if(sti(rand(100)+enemy.skill.Fencing) < sti(weapon.disarm)+sti(attack.skill.Fencing) + disarmbonus - disarmpenalty)
			{
				LAi_CharacterPlaySound(enemy,"OBJECTS\duel\sword_fallen.wav");
				string enemy_blade = GetCharacterEquipByGroup(enemy,BLADE_ITEM_TYPE);
				RemoveCharacterEquip(enemy,  BLADE_ITEM_TYPE );
				GiveItem2Character(attack, enemy_blade);

				if ( enemy.chr_ai.group !=  LAI_GROUP_PLAYER && !bAbordageStarted )
				// no disarming opponents during boarding
				{
					LAi_SetCitizenTypeNoGroup(enemy);
					Log_SetStringToLog(TranslateString("","Opponent disarmed !"));
				}
				else
				{
					TakeItemFromCharacter(enemy, enemy_blade);
					if ( sti(enemy.index) != GetMainCharacterIndex() && !bAbordageStarted ) // if NOT player
					// officers safe from being disarmed boarding; player NOT safe from being disarmed during boarding
					{
						RemoveCharacterEquip(attack, BLADE_ITEM_TYPE );			// makes enemy use your blade against your officer
						EquipCharacterByItem(attack, enemy_blade);			// and enables you to get it back by killing him/her
						Log_SetStringToLog(TranslateString("","One of your officers was disarmed!"));
						LAi_tmpl_afraid_SetAfraidCharacter(enemy, attack, true);	// makes officer flee
						LAi_SetAfraidDead(enemy);
					}
					else
					{
						RemoveCharacterEquip(attack, BLADE_ITEM_TYPE );			// makes enemy use your blade against you
						EquipCharacterByItem(attack, enemy_blade);			// and enables you to get it back by killing him/her
						EquipCharacterByItem(enemy, "bladeX4");
						Log_SetStringToLog(TranslateString("","You were disarmed!"));
					}
				}
			}
		}

		//   
		// ccc LAi_group_Attack(attack, enemy);	// line moved into "stealth" section


		// 

		// ccc particle effects, runs only if effect defined  in inititems.c
		LAi_PlayHitGFX(attack, enemy, weapon, effects_to_play); // NK do in centralized function 05-07-10

		if(!CheckAttribute(weapon, "fist" ) || !CheckAttribute(weapon, "pistolclub" ))	// PB: Fists will only do damage once with one hit, JRH: same for pclub
		{LAi_ApplyCharacterAttackDamage(attack, enemy, attackDmg, hitDmg);}
	}

	//JRH -->
	if(CheckAttribute(weapon, "id") && weapon.id == "bladeanchor")
	{
		if(CheckAttribute(enemy, "id") && enemy.id == "pir_cap10")
		{
			if(CheckAttribute(attack, "quest.Bunce") && attack.quest.Bunce == "in_boat")
			{
				attack.quest.Bunce = "awaken";
				LAi_SetFightMode(attack, false);
				LAi_LocationFightDisable(&Locations[FindLocation("wr_cave_shore")], true);

				LAi_QuestDelay("Bunce_wakes_up", 1.0);
			}
		}
	}
	//<-- JRH

	// TIH --> prevent stunned characters getting hit, causing everyone to go hostile with them
	if(CheckAttribute(enemy, "stuntime"))
	{
		SetHostile = false;
	}
	// TIH <--

	if(SetHostile) // if we are setting enemy hostile to us (and haven't yet)
	{
		if(!LAi_IsDead(enemy)) { LAi_group_Attack(attack, enemy); } // if not dead, alarm!
		else // otherwise...
		{
			// for now, just behave like normal. When I have a chance, I'll check near characters vs. see/hear radius.
			//int num = FindNearCharacters(enemy, float rad, float ax, float testAng, float nearDist, bool isVisibleTest, bool isSort)
			LAi_group_Attack(attack, enemy);
		}
	}
	// ccc special weapon assembly kit end

	if(LAi_IsDead(enemy) && CheckAttribute(enemy,"itemtrade"))
	//if you killed a merchant
	{
		if(attack.location == "wr_ships" || attack.location == "wr_gall_captain")
		{
	 		//Log_SetStringToLog("LAi_events ambush avoided");
			return;				//JRH
		}

		logit(TranslateString("","The Merchantguild's watchmen are very vigilant..."));
		// TIH --> bug fix... this now works right Jul23'06
		int numGuards = 30 - LAi_numloginedcharacters;		// LDH - changed from 32 to TIH's original 30
		if ( numGuards > 0 ) Ambush("guards", numGuards, "enemy", "friend","");
		if ( sti(attack.index) == GetMainCharacterIndex() ) {
			ref PlayerChar = GetMainCharacter();
			ChangeCharacterReputation(PlayerChar, -100);// TIH MUST BE INT Nov17'06
			if ( CheckAttribute(enemy,"nation") ) {
				SetNationRelation2MainCharacter(sti(enemy.nation), RELATION_ENEMY);
				LooseLetterOfMarque(sti(enemy.nation));
				LeaveService(PlayerChar, sti(enemy.nation), false);
				SetRMRelation(PlayerChar, sti(enemy.nation), REL_WAR);
			}
			PlayerChar.nation = PIRATE;
			if(GetRMRelation(PlayerChar, PIRATE) < REL_AMNESTY) SetRMRelation(PlayerChar, PIRATE, REL_AMNESTY);
			UpdateRelations();
			RefreshBattleInterface();
		}
		// TIH <--
	}

	// unchanged code begins:

	// 
	string func = attack.chr_ai.type;
	if(func == "") return;
	func = "LAi_type_" + func + "_Attack";
	call func(attack, enemy, attackDmg, hitDmg);
	//  
	LAi_group_UpdateTargets(enemy);
	func = enemy.chr_ai.type;
	if(func == "") return;
	func = "LAi_type_" + func + "_Attacked";
	call func(enemy, attack);
	func = "LAi_type_" + enemy.chr_ai.type + "_CharacterUpdate";
	call func(enemy, 0.0001);
	//LanguageCloseFile(tmpLangFileID);
}

void LAi_CharacterBlock()
{
	aref attack = GetEventData();
	aref enemy = GetEventData();
	float attackDmg = GetEventData();
	float hitDmg = GetEventData();

	// PB: Bladedamage mod -->
	int bladedamage_usage;
	int bladedamage_level = 0; // changed by MAXIMUS
	int total_chance;
	string BladeID;
	string BladeBaseID;
	string weaponID;
	aref weapon;
	bool DecreaseQuality;
	bool BladeBreak;
	bool Continue_Bladedamage;

	ref PChar = GetMainCharacter();

// Counters to gather information for balancing this mod -->
	if(sti(enemy.index) == GetMainCharacterIndex())
	// This counts how many times an enemy hit the PChar while the PChar was blocking
	{
		if(!CheckAttribute(PChar,"hitduringblock")) PChar.hitduringblock = 0;
		PChar.hitduringblock = sti(PChar.hitduringblock) + 1;
	}

	if(sti(attack.index) == GetMainCharacterIndex())
	// This counts how many times the PChar hit an enemy while the enemy was blocking
	{
		if(!CheckAttribute(PChar,"hitwhileblocking")) PChar.hitwhileblocking = 0;
		PChar.hitwhileblocking = sti(PChar.hitwhileblocking) + 1;
	}
// Counters to gather information for balancing this mod <--

	// Code for the bladedamage for the enemy:
	if(BLADEDAMAGE_ENABLED && ENABLE_WEAPONSMOD && GetCharacterEquipByGroup(enemy,BLADE_ITEM_TYPE) != "bladeX4" && !bDeckEnter && GetItemQualityName(GetItemQualityByID(GetCharacterEquipByGroup(enemy,BLADE_ITEM_TYPE))) != "") // PB
	{
		if(!CheckAttribute(enemy,"bladedamagecounter"))
		{
			if(sti(enemy.index) == GetMainCharacterIndex())
		 	{enemy.bladedamagecounter = 0;}
			else
			{enemy.bladedamagecounter = rand(BLADEDAMAGE_RAND + BLADEDAMAGE_BASE) - 0.5 * BLADEDAMAGE_RAND;} // to decrease the chance of an enemy's blade breaking on first hit
		}
		enemy.bladedamagecounter = sti(enemy.bladedamagecounter) + 1;
		// Counts the amount of strokes you performed with your blade

			BladeID = GetCharacterEquipByGroup(enemy,BLADE_ITEM_TYPE);
		if (findSubStr(&BladeID, "+", 0) > -1 || findSubStr(&BladeID, "-", 0) > -1)
			BladeBaseID = strcut(&BladeID, 0, strlen(BladeID) - 3);
		else
			BladeBaseID = BladeID;

		weaponID = GetCharacterEquipByGroup(enemy,BLADE_ITEM_TYPE); // defines weaponname
		Items_FindItem(weaponID, &weapon);	// defines object for weaponattributes

		DecreaseQuality = false;
		BladeBreak = false;
		Continue_Bladedamage = true;

		// Bladedamage based on the usage of your blade
		// -------------------------------------------------------
		bladedamage_usage = enemy.bladedamagecounter;

		//LogIt("Bladedamage Usage = " + bladedamage_usage);

		// Bladedamage based on your level vs the blade's minlevel
		// -------------------------------------------------------
		if(CheckAttribute(weapon,"minlevel") && sti(weapon.minlevel) < 95) bladedamage_level = sti(weapon.minlevel) - sti(enemy.rank); // changed by MAXIMUS
		if(bladedamage_level < 0) bladedamage_level = 0;
		bladedamage_level = 0.01 * (BLADEDAMAGE_BASE + BLADEDAMAGE_RAND) * sti(bladedamage_level); // to keep this effect having impact, even if BASE or RAND are increased

		//LogIt("Bladedamage Level = " + bladedamage_level);

		total_chance = sti(bladedamage_usage) + sti(bladedamage_level);

		if(total_chance > rand(BLADEDAMAGE_RAND) + BLADEDAMAGE_BASE)
		{DecreaseQuality = true;}

		//LogIt("Total chance points = " + total_chance + " for character " + enemy.name + " " + enemy.lastname);

		// Broken blades break VERY quickly!!!
		if(GetItemQualityByID(BladeID) == 0 && rand(sti(bladedamage_usage)) > 10) // Add some randomness
		{DecreaseQuality = true;}

		if(DecreaseQuality)
		{
			RemoveCharacterEquip(enemy, BLADE_ITEM_TYPE);
			TakeItemFromCharacter(enemy, BladeID);

			enemy.bladedamagecounter = 0;

			switch(GetItemQualityByID(BladeID))
			{
				case 0:
					LAi_CharacterPlaySound(enemy, "OBJECTS\duel\sword_broken.wav");//MAXIMUS
					BladeBreak = true;
				break;

				case 1:
					if(enemy.chr_ai.group ==  LAI_GROUP_PLAYER)
					{LAi_CharacterPlaySound(enemy, "OBJECTS\duel\sword_broken.wav");}//MAXIMUS
					// To only play the sound for player-related characters

					// To give broken blades
					if(enemy.chr_ai.group ==  LAI_GROUP_PLAYER || BLADEDAMAGE_KEEPBROKENBLADE)
					{
						GiveItem2Character(enemy, BladeBaseID + "-2");
						EquipCharacterByItem(enemy, BladeBaseID + "-2");
					}
					BladeBreak = true;
				break;

				case 2:
					GiveItem2Character(enemy, BladeBaseID + "-1");
					EquipCharacterByItem(enemy, BladeBaseID + "-1");
				break;

				case 3:
					GiveItem2Character(enemy, BladeBaseID);
					EquipCharacterByItem(enemy, BladeBaseID);
				break;

				case 4:
					GiveItem2Character(enemy, BladeBaseID + "+1");
					EquipCharacterByItem(enemy, BladeBaseID + "+1");
				break;

				case 5:
					GiveItem2Character(enemy, BladeBaseID + "+2");
					EquipCharacterByItem(enemy, BladeBaseID + "+2");
				break;
			}

			if(BladeBreak)
			{
				if(sti(enemy.index) == GetMainCharacterIndex()){
					Continue_Bladedamage = false;
					LogIt("Your blade decreased in quality!"); }
				if(CheckAttribute(enemy, "nodisarm")) Continue_Bladedamage = false;
				if(enemy.chr_ai.group == LAI_GROUP_PLAYER) Continue_Bladedamage = false;
				if(bAbordageStarted) Continue_Bladedamage = false;

				if(Continue_Bladedamage && rand(1) > 0)
				{
					LAi_SetCitizenTypeNoGroup(enemy);
				}
				else
				{
					if(CheckCharacterItem(enemy, FindCharacterItemByGroup(enemy, BLADE_ITEM_TYPE)) && GetItemQualityByID(FindCharacterItemByGroup(enemy, BLADE_ITEM_TYPE)) != 0 && BLADEDAMAGE_USEOTHERBLADE)
					// If character has another blade and the other blade is not broken and USEOTHERBLADE is on
					{
						// Then use the other blade
						EquipCharacterByItem(enemy, FindCharacterItemByGroup(enemy, BLADE_ITEM_TYPE));
					}
					else
					{
						// Else use the default blade
						if(!CheckCharacterItem(enemy, BLADEDAMAGE_DEFAULTBLADE))
						{GiveItem2Character(enemy, BLADEDAMAGE_DEFAULTBLADE);}
						// To prevent characters being given another defaultblade if they already have one
						EquipCharacterByItem(enemy, BLADEDAMAGE_DEFAULTBLADE);
					}
				}
			}
		}
	}

	// Code for the bladedamage for the attack:
	if(BLADEDAMAGE_ENABLED && ENABLE_WEAPONSMOD && GetCharacterEquipByGroup(attack,BLADE_ITEM_TYPE) != "bladeX4" && !bDeckEnter && GetItemQualityName(GetItemQualityByID(GetCharacterEquipByGroup(attack,BLADE_ITEM_TYPE))) != "") // PB
	{
		if(!CheckAttribute(attack,"bladedamagecounter"))
		{
			if(sti(attack.index) == GetMainCharacterIndex())
		 	{attack.bladedamagecounter = 0;}
			else
			{attack.bladedamagecounter = rand(BLADEDAMAGE_RAND + BLADEDAMAGE_BASE) - 0.5 * BLADEDAMAGE_RAND;} // to decrease the chance of an enemy's blade breaking on first hit
		}
		attack.bladedamagecounter = sti(attack.bladedamagecounter) + 1;
		// Counts the amount of strokes you performed with your blade

			BladeID = GetCharacterEquipByGroup(attack,BLADE_ITEM_TYPE);
		if (findSubStr(&BladeID, "+", 0) > -1 || findSubStr(&BladeID, "-", 0) > -1)
			BladeBaseID = strcut(&BladeID, 0, strlen(BladeID) - 3);
		else
			BladeBaseID = BladeID;

		weaponID = GetCharacterEquipByGroup(attack,BLADE_ITEM_TYPE); // defines weaponname
		Items_FindItem(weaponID, &weapon);	// defines object for weaponattributes

		DecreaseQuality = false;
		BladeBreak = false;
		Continue_Bladedamage = true;

		// Bladedamage based on the usage of your blade
		// -------------------------------------------------------
		bladedamage_usage = attack.bladedamagecounter;

		//LogIt("Bladedamage Usage = " + bladedamage_usage);

		// Bladedamage based on your level vs the blade's minlevel
		// -------------------------------------------------------
		if(CheckAttribute(weapon,"minlevel") && sti(weapon.minlevel) < 95)  bladedamage_level = sti(weapon.minlevel) - sti(attack.rank); // changed by MAXIMUS
		if(bladedamage_level < 0) bladedamage_level = 0;
		bladedamage_level = 0.01 * (BLADEDAMAGE_BASE + BLADEDAMAGE_RAND) * sti(bladedamage_level); // to keep this effect having impact, even if BASE or RAND are increased

		//LogIt("Bladedamage Level = " + bladedamage_level);

		total_chance = sti(bladedamage_usage) + sti(bladedamage_level);

		if(total_chance > rand(BLADEDAMAGE_RAND) + BLADEDAMAGE_BASE)
		{DecreaseQuality = true;}

		//LogIt("Total chance points = " + total_chance + " for character " + attack.name + " " + attack.lastname);

		// Broken blades break VERY quickly!!!
		if(GetItemQualityByID(BladeID) == 0 && rand(sti(bladedamage_usage)) > 10) // Add some randomness
		{DecreaseQuality = true;}

		if(DecreaseQuality)
		{
			RemoveCharacterEquip(attack, BLADE_ITEM_TYPE);
			TakeItemFromCharacter(attack, BladeID);

			attack.bladedamagecounter = 0;

			switch(GetItemQualityByID(BladeID))
			{
				case 0:
					LAi_CharacterPlaySound(attack, "OBJECTS\duel\sword_broken.wav");//MAXIMUS
					BladeBreak = true;
				break;

				case 1:
					if(attack.chr_ai.group ==  LAI_GROUP_PLAYER)
					{LAi_CharacterPlaySound(attack, "OBJECTS\duel\sword_broken.wav");}//MAXIMUS
					// To only play the sound for player-related characters

					// To give broken blades
					if(attack.chr_ai.group ==  LAI_GROUP_PLAYER || BLADEDAMAGE_KEEPBROKENBLADE)
					{
						GiveItem2Character(attack, BladeBaseID + "-2");
						EquipCharacterByItem(attack, BladeBaseID + "-2");
					}
					BladeBreak = true;
				break;

				case 2:
					GiveItem2Character(attack, BladeBaseID + "-1");
					EquipCharacterByItem(attack, BladeBaseID + "-1");
				break;

				case 3:
					GiveItem2Character(attack, BladeBaseID);
					EquipCharacterByItem(attack, BladeBaseID);
				break;

				case 4:
					GiveItem2Character(attack, BladeBaseID + "+1");
					EquipCharacterByItem(attack, BladeBaseID + "+1");
				break;

				case 5:
					GiveItem2Character(attack, BladeBaseID + "+2");
					EquipCharacterByItem(attack, BladeBaseID + "+2");
				break;
			}

			if(BladeBreak)
			{
				if(sti(attack.index) == GetMainCharacterIndex()) Continue_Bladedamage = false;
				if(CheckAttribute(attack, "nodisarm")) Continue_Bladedamage = false;
				if(attack.chr_ai.group == LAI_GROUP_PLAYER) Continue_Bladedamage = false;
				if(bAbordageStarted) Continue_Bladedamage = false;

				if(Continue_Bladedamage && rand(1) > 0)
				{
					LAi_SetCitizenTypeNoGroup(attack);
				}
				else
				{
					if(CheckCharacterItem(attack, FindCharacterItemByGroup(attack, BLADE_ITEM_TYPE)) && GetItemQualityByID(FindCharacterItemByGroup(attack, BLADE_ITEM_TYPE)) != 0 && BLADEDAMAGE_USEOTHERBLADE)
					// If character has another blade and the other blade is not broken and USEOTHERBLADE is on
					{
						// Then use the other blade
						EquipCharacterByItem(attack, FindCharacterItemByGroup(attack, BLADE_ITEM_TYPE));
					}
					else
					{
						// Else use the default blade
						if(!CheckCharacterItem(attack, BLADEDAMAGE_DEFAULTBLADE))
						{GiveItem2Character(attack, BLADEDAMAGE_DEFAULTBLADE);}
						// To prevent characters being given another defaultblade if they already have one
						EquipCharacterByItem(attack, BLADEDAMAGE_DEFAULTBLADE);
					}
				}
			}
		}
	}
	// PB: Bladedamage mod <--

	//JRH --> weapon sound also when blocking for planks etc
	weaponID = GetCharacterEquipByGroup(enemy,BLADE_ITEM_TYPE); // defines weaponname
	Items_FindItem(weaponID, &weapon);	// defines object for weaponattributes

	if( CheckAttribute(weapon, "sound" ) ) { PlaySound( weapon.sound ); }
		// plays soundfile if defined in items\itemsinit.c

	string weaponID3 = GetCharacterEquipByGroup(attack,BLADE_ITEM_TYPE);
	aref weapon3;
	Items_FindItem(weaponID3, &weapon3);	// defines object for weaponattributes

	if( CheckAttribute(weapon3, "sound" ) ) { PlaySound( weapon3.sound ); }
		// plays soundfile if defined in items\itemsinit.c
   	//<-- JRH

	//skillearning(attack, "Fencing", 1);	// ccc skillearning

	//   
	LAi_group_Attack(attack, enemy);
	// 
	LAi_ApplyCharacterBlockDamage(attack, enemy, attackDmg, hitDmg);
	// 
	string func = attack.chr_ai.type;
	if(func == "") return;
	func = "LAi_type_" + func + "_Block";
	call func(attack, enemy, attackDmg, hitDmg);
	//  
	LAi_group_UpdateTargets(enemy);
	func = enemy.chr_ai.type;
	if(func == "") return;
	func = "LAi_type_" + func + "_Attacked";
	call func(enemy, attack);
	func = "LAi_type_" + enemy.chr_ai.type + "_CharacterUpdate";
	call func(enemy, 0.0001);
}

void LAi_CharacterFire()
	// ccc jul 05 Most code moved into the new LAi_CharacterFireExecute()
	// This now only gets the EventData from the original targeting process and passes them on if we don't correct them
{
	aref attack = GetEventData();
	aref enemy = GetEventData();
	float kDist = GetEventData();	//0..1
	int isFindedEnemy = GetEventData();

	// ccc jul05 shooting past corpses and barricades
	if(isFindedEnemy)
	{
		bool bPass = CheckAttribute(enemy,"corpse")==true;
		(!bPass) bPass = enemy.name=="A ";
		if(bPass)// if original target is corpse or barricade
		{
			int nm = FindNearCharacters(enemy, 2.5, -1.0, -1.0, 0.001, false, true);
			for(int k = 0; k <= nm; k++)
				// checks for other chrs around original target and loops through them
			{
				//changed by MAXIMUS - [fix - CheckAttribute] -->
				int ix = -1;
				if(CheckAttribute(chrFindNearCharacters[k],"index")) ix = sti(chrFindNearCharacters[k].index);
				if(ix == -1) return;
				//changed by MAXIMUS - [fix - CheckAttribute] <--
				ref findC = GetCharacter(ix);
				if(!CheckAttribute(findC,"corpse") && findC.name != "A " && findC.name != attack.name)// if bystander is neither corpse, barricade or shooter himself...
				{
					LAi_CharacterFireExecute(attack, findC, kDist, isFindedEnemy);//... shooting is executed with bystander as new target
					break;
				}
			}
		}
		else
		{
			LAi_CharacterFireExecute(attack, enemy, kDist, isFindedEnemy);	// unchanged targetdata passed on
		}
	}
	else LAi_CharacterFireExecute(attack, enemy, kDist, isFindedEnemy);	// unchanged targetdata passed on
}


void LAi_CharacterFireExecute(aref attack, aref enemy, float kDist, int isFindedEnemy)
	// ccc jul 05 Former LAi_CharacterFire() function minus the EventData yielded by the original targeting process
	// Shooting can now also be executed from other functions with other data
{
	//int tmpLangFileID = LanguageOpenFile("interface_strings.txt");
	//ccc aref attack = GetEventData();
	//ccc aref enemy = GetEventData();
	//ccc float kDist = GetEventData();
	//ccc int isFindedEnemy = GetEventData();
	// 
	if(!CheckAttribute(attack, "chr_ai.charge")) attack.chr_ai.charge = "0";
	float charge = stf(attack.chr_ai.charge) - 1.0;
	if(charge <= 0.0)
	{
		charge = 0.0;
		attack.chr_ai.chargeprc = "1";
	}
	attack.chr_ai.charge = charge;
	// ,    

//JRH moved up block from below
	string weaponID = GetCharacterEquipByGroup(attack,GUN_ITEM_TYPE);	// defines weaponname
	aref weapon;
	Items_FindItem(weaponID, &weapon);	// defines object for weaponattributes

	float u, v, w;          		//JRH coordinates for effects
	GetCharacterPos(attack, &u, &v, &w);    //JRH determines position of initial target

	if(isFindedEnemy == 0)
	{
		//       

		if(CheckAttribute(weapon, "id") && weapon.id == "pistoltinderbox")
		{
			//JRH tinder box
			CreateParticleSystem("gunfire_red" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
			CreateParticleSystem("stars_fire" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
			PlaySound("OBJECTS\duel\GI_ValidClick.wav");

			LAi_QuestDelay("tinder_box", 1.0);
			return;
		}

	    //JRH light fire -->
		if(attack.location == "wr_gunroom")
		{
			CreateParticleSystem("gunfire_red" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
			CreateParticleSystem("stars_fire" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
			PlaySound("OBJECTS\duel\GI_ValidClick.wav");

			if(CheckAttribute(attack,"quest.rum_damper") && attack.quest.rum_damper == "closed")
			{
				Log_SetStringToLog("You need oxygen!");

				LAi_QuestDelay("gunroom_disable_fightmode", 0.5);
			}

			if(CheckAttribute(attack,"quest.rum_damper") && attack.quest.rum_damper == "half_open")
			{
				if(Locations[FindLocation(attack.location)].models.always.locators == "tavern02_locators_JRH1")
				{
					if(CheckAttribute(attack,"quest.rum_fuel") && attack.quest.rum_fuel == "wood")
		    			{
						Locations[FindLocation(attack.location)].models.always.locators = "tavern02_locators_JRH1_F";
						attack.quest.rum_fire = "lit";
						Locations[FindLocation(attack.location)].models.always.l1 = "wood_lit";

						LAi_QuestDelay("damper", 0.5);
					}
					else
					{
						if(CheckAttribute(attack,"quest.rum_fuel") && attack.quest.rum_fuel == "sack")
		    				{
							Locations[FindLocation(attack.location)].models.always.locators = "tavern02_locators_JRH1_F";
							attack.quest.rum_fire = "lit";
							Locations[FindLocation(attack.location)].models.always.l1 = "sack2_lit";

							LAi_QuestDelay("damper", 0.5);
						}
					}
					else
					{
						Log_SetStringToLog("Get some wood first!");

						LAi_QuestDelay("gunroom_disable_fightmode", 0.5);
					}
				}
			}

			if(CheckAttribute(attack,"quest.rum_damper") && attack.quest.rum_damper == "open")
			{
				if(Locations[FindLocation(attack.location)].models.always.locators == "tavern02_locators_JRH2")
				{
					if(CheckAttribute(attack,"quest.rum_fuel") && attack.quest.rum_fuel == "wood")
		    			{
						attack.quest.rum_fire = "lit";
						Locations[FindLocation(attack.location)].models.always.l1 = "wood_lit";
						Locations[FindLocation(attack.location)].models.always.locators = "tavern02_locators_JRH2_F";

						LAi_QuestDelay("damper", 0.5);
					}
					else
					{
						if(CheckAttribute(attack,"quest.rum_fuel") && attack.quest.rum_fuel == "sack")
		    				{
							Locations[FindLocation(attack.location)].models.always.locators = "tavern02_locators_JRH1_F";
							attack.quest.rum_fire = "lit";
							Locations[FindLocation(attack.location)].models.always.l1 = "sack2_lit";

							LAi_QuestDelay("damper", 0.5);
						}
					}
					else
					{
						Log_SetStringToLog("Get some wood first!");

						LAi_QuestDelay("gunroom_disable_fightmode", 0.5);
					}
				}
			}

			if(CheckAttribute(attack,"quest.rum_damper") && attack.quest.rum_damper == "half_closed")
			{
				if(Locations[FindLocation(attack.location)].models.always.locators == "tavern02_locators_JRH1")
				{
					if(CheckAttribute(attack,"quest.rum_fuel") && attack.quest.rum_fuel == "wood")
		    			{
						attack.quest.rum_fire = "lit";
						Locations[FindLocation(attack.location)].models.always.l1 = "wood_lit";
						Locations[FindLocation(attack.location)].models.always.locators = "tavern02_locators_JRH1_F";

						LAi_QuestDelay("damper", 0.5);
					}
					else
					{
						if(CheckAttribute(attack,"quest.rum_fuel") && attack.quest.rum_fuel == "sack")
		    				{
							Locations[FindLocation(attack.location)].models.always.locators = "tavern02_locators_JRH1_F";
							attack.quest.rum_fire = "lit";
							Locations[FindLocation(attack.location)].models.always.l1 = "sack2_lit";

							LAi_QuestDelay("damper", 0.5);
						}
					}
					else
					{
						Log_SetStringToLog("Get some wood first!");

						LAi_QuestDelay("gunroom_disable_fightmode", 0.5);
					}
				}
			}

			return;
		}
		else
		{
			if(attack.location == "wr_farm_corridor")
			{
				if(Locations[FindLocation("wr_farm_corridor")].models.always.locators == "StoreSmall_locators_JRH_dark")
				{
					if(CheckAttribute(weapon, "shottype") && weapon.shottype == "pb" || weapon.shottype == "pg")
					{
						//JRH tinder box STYLE
						CreateParticleSystem("gunfire_red" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
						CreateParticleSystem("stars_fire" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
						PlaySound("OBJECTS\duel\GI_ValidClick.wav");

						Locations[FindLocation("wr_farm_corridor")].filespath.textures = "locations\inside\Corridor\normal";
						Locations[FindLocation("wr_farm_corridor")].models.always.locators = "StoreSmall_locators_JRH_normal";

						if(CheckAttribute(attack, "quest.scroll46") && attack.quest.scroll46 == "picked_up")
						{
							Locations[FindLocation("wr_farm_corridor")].models.always.l1 = "keymiddle";
							attack.quest.keymiddle = "on_counter";
						}

						LAi_QuestDelay("corridor_lit", 1.0);
					}
				}
				return;
			}
		}
		else
		{
			if(attack.location == "wr_mine_control")
			{
				float Php;
				Php = LAi_GetCharacterHP(attack);
				//int Php3;
				//Php3 = Php/3;
				int Php4; int Php2;
				Php4 = Php/4; Php2 = Php/2;

				CreateParticleSystem("gunfire_red" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
				CreateParticleSystem("stars_fire" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
				PlaySound("OBJECTS\duel\GI_ValidClick.wav");

				if(Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH1_G" || Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH2_G" || Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH3_G")
				{
					//Log_SetStringToLog("Reading 1");

					if(CheckAttribute(attack,"quest.torch_enable") && attack.quest.torch_enable == "no")
		    			{
						if(CheckAttribute(attack,"quest.gas_level") && attack.quest.gas_level == "3")
						{

							if(Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH1_G")
							{
								//Log_SetStringToLog("Reading 3");
								Locations[FindLocation(attack.location)].models.always.locators = "d02_l_JRH1_F";
							}

							if(Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH2_G")
							{
								//Log_SetStringToLog("Reading 4");
								Locations[FindLocation(attack.location)].models.always.locators = "d02_l_JRH2_F";
							}

							if(Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH3_G")
							{
								//Log_SetStringToLog("Reading 5");
								Locations[FindLocation(attack.location)].models.always.locators = "d02_l_JRH3_F";
							}

							CreateParticleSystem("fort_fire" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );

							PlaySound("OBJECTS\SHIPCHARGE\CR18C.wav");
							PlaySound("OBJECTS\DUEL\pistol_small2.wav");
							PlaySound("OBJECTS\DUEL\pistol_medium3.wav");

							LAi_ApplyCharacterDamage(attack, Php2);

							LAi_QuestDelay("mine_lights_fire_on_dmg2", 0.5);
						}
						else
						{
							if(CheckAttribute(attack,"quest.gas_level") && attack.quest.gas_level == "4")
								LAi_QuestDelay("boiling_explosion", 0.1);
						}
						else
						{
							Log_SetStringToLog(TranslateString("","Not a bad idea, but light the gas!"));
							//Log_SetStringToLog("Reading 6");
						}
					}
					else
					{
						//Log_SetStringToLog("Reading 2");

						if(Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH1_G")
						{
							//Log_SetStringToLog("Reading 3");
							Locations[FindLocation(attack.location)].models.always.locators = "d02_l_JRH1_F";
						}

						if(Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH2_G")
						{
							//Log_SetStringToLog("Reading 4");
							Locations[FindLocation(attack.location)].models.always.locators = "d02_l_JRH2_F";
						}

						if(Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH3_G")
						{
							//Log_SetStringToLog("Reading 5");
							Locations[FindLocation(attack.location)].models.always.locators = "d02_l_JRH3_F";
						}


						if(CheckAttribute(attack,"quest.gas_level") && attack.quest.gas_level == "4")
								LAi_QuestDelay("boiling_explosion", 0.1);

						if(CheckAttribute(attack,"quest.gas_level") && attack.quest.gas_level == "2")
						{
							PlaySound("OBJECTS\DUEL\pistol_bbus.wav");
							PlaySound("OBJECTS\DUEL\pistol_small2.wav");

							LAi_ApplyCharacterDamage(attack, Php4);

							LAi_QuestDelay("mine_lights_fire_on_dmg1", 0.5);
						}
						else
						{
							if(CheckAttribute(attack,"quest.gas_level") && attack.quest.gas_level == "3")
							{
								CreateParticleSystem("gunfire" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );

								PlaySound("OBJECTS\SHIPCHARGE\CR18C.wav");
								PlaySound("OBJECTS\DUEL\pistol_small2.wav");
								PlaySound("OBJECTS\DUEL\pistol_medium3.wav");

								LAi_ApplyCharacterDamage(attack, Php2);

								LAi_QuestDelay("mine_lights_fire_on_dmg2", 0.5);
							}
						}
						else LAi_QuestDelay("mine_lights_fire_on", 0.5);
					}
				}

				if(Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH1" || Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH2" || Locations[FindLocation(attack.location)].models.always.locators == "d02_l_JRH3")
				{
					//Log_SetStringToLog("Reading 7");
					if(CheckAttribute(attack,"quest.torch_enable") && attack.quest.torch_enable == "yes")
					{
						//Log_SetStringToLog("Reading 8");
		    				Log_SetStringToLog(TranslateString("","Turn on the gas first!"));
						Log_SetStringToLog("Turn on the gas first!");
					}
				}

				return;
			}
		}
	    // <-- JRH light fire
		else
		{
			if(attack.location == "wr_animists")
			{
				if(CheckAttribute(attack,"quest.cell2_check") && attack.quest.cell2_check == "on")
				{
					PlaySound("PEOPLE\spade.wav");
					LAi_QuestDelay("sledge_to_defense", 1.0);
					return;
				}
				else
				{
					PlaySound("PEOPLE\spade.wav");
					LAi_QuestDelay("sledge_to_minebomb", 1.0);
					return;
				}
			}
		}
		else
		{
			if(attack.location == "wr_farm_alchemy")
			{
				if(CheckAttribute(attack,"quest.lab_position") && attack.quest.lab_position == "fireplace")
				{
					if(CheckAttribute(attack,"quest.apparatus_level"))
					{
						if(attack.quest.apparatus_level == "cauldron")
						{
							if(CheckAttribute(weapon, "id") )
							{
								if(weapon.id == "pistolretort")
								{
									//place retort!
									if(Locations[FindLocation("wr_farm_alchemy")].models.always.locators == "mediumhouse01_locators_JRH2")
									{
										if(CheckAttribute(attack,"quest.cauldron") && attack.quest.cauldron == "empty")
											PlaySound("INTERFACE\glass1.wav");
										if(CheckAttribute(attack,"quest.cauldron") && attack.quest.cauldron == "water")
											PlaySound("INTERFACE\glass2.wav");
										LAi_SetPoorType(attack);

										LAi_QuestDelay("alchemy_glass_explosion", 0.5);
										return;
									}

									if(Locations[FindLocation("wr_farm_alchemy")].models.always.locators == "mediumhouse01_locators_JRH1")
									{
										if(CheckAttribute(attack,"quest.cauldron") && attack.quest.cauldron == "empty")
										{
											PlaySound("INTERFACE\glass1.wav");
											LAi_SetPoorType(attack);

											LAi_QuestDelay("alchemy_glass_explosion", 0.5);
											return;
										}

										if(CheckAttribute(attack,"quest.cauldron") && attack.quest.cauldron == "water")
										{
											PlaySound("INTERFACE\glass2.wav");

											RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
											TakeItemFromCharacter(attack, "pistolretort");

											Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_E0";
											attack.quest.apparatus_level = "retort";
											attack.quest.retort = "yes";

											LAi_QuestDelay("place_distillery_item", 0.5);
										}
									}

									if(Locations[FindLocation("wr_farm_alchemy")].models.always.locators == "mediumhouse01_locators_JRH0")
									{
										if(CheckAttribute(attack,"quest.cauldron") && attack.quest.cauldron == "empty")
											PlaySound("INTERFACE\glass1.wav");
										if(CheckAttribute(attack,"quest.cauldron") && attack.quest.cauldron == "water")
											PlaySound("INTERFACE\glass2.wav");

										RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
										TakeItemFromCharacter(attack, "pistolretort");

										Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_E0";
										attack.quest.apparatus_level = "retort";
										attack.quest.retort = "yes";

										LAi_QuestDelay("place_distillery_item", 0.5);
									}
								}
							}
						}

						if(attack.quest.apparatus_level == "top")
						{
							if(CheckAttribute(weapon, "id") )
							{
								if(weapon.id == "pistolglass_tube")
								{
									//place glass tube!
									PlaySound("INTERFACE\glass1.wav");
									RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
									TakeItemFromCharacter(attack, "pistolglass_tube");

									Locations[FindLocation("wr_farm_alchemy")].models.always.l12 = "glass_tube3";
									attack.quest.apparatus_level = "glass_tube";
									attack.quest.glass_tube = "yes";

									LAi_QuestDelay("place_distillery_item", 0.5);
								}
							}
						}
					}
				}

				if(CheckAttribute(attack,"quest.lab_position") && attack.quest.lab_position == "mixtable")
				{
					int ps = GetCharacterItem(attack, "pistolsalt");
					int pn = GetCharacterItem(attack, "pistolnitre");
					int pc = GetCharacterItem(attack, "pistolcopperas");

					//EMPTY BOTTLE
					if(CheckAttribute(attack, "quest.mixtable_bottle") && attack.quest.mixtable_bottle == "ME0")
					{
						if(CheckAttribute(weapon, "id") )
						{
							if(weapon.id == "pistolsalt")
							{
								//sulf needed - else stock here!
								if (CheckCharacterItem(attack, "bladebottle_CT1_sulf"))
								{
									PlaySound("PEOPLE\grass_noise.wav");
									locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MS1_salt";
									attack.quest.mixtable_bottle = "MS1_salt";

									if(ps == 1) RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
									TakeItemFromCharacter(attack, "pistolsalt");

									LAi_QuestDelay("place_mixtable_item", 1.0);
									return;
								}
							}

							if(weapon.id == "pistolnitre")
							{
								//sulf needed - else stock here!
								if (CheckCharacterItem(attack, "bladebottle_CT1_sulf"))
								{
									PlaySound("PEOPLE\grass_noise.wav");
									locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MS1_chil";
									attack.quest.mixtable_bottle = "MS1_chil";

									if(pn == 1) RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
									TakeItemFromCharacter(attack, "pistolnitre");

									LAi_QuestDelay("place_mixtable_item", 1.0);
									return;
								}
							}

							if(weapon.id == "pistolcopperas")
							{
								PlaySound("PEOPLE\grass_noise.wav");
								locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MV1";
								attack.quest.mixtable_bottle = "MV1";

								if(pc == 1) RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
								TakeItemFromCharacter(attack, "pistolcopperas");

								LAi_QuestDelay("place_mixtable_item", 1.0);
								return;
							}
						}
					}

					//HALF FULL BOTTLE: WATER
					if(CheckAttribute(attack, "quest.mixtable_bottle") && attack.quest.mixtable_bottle == "MW1")
					{
						if(CheckAttribute(weapon, "id") && weapon.id == "pistolcopperas")
						{
							PlaySound("PEOPLE\grass_noise.wav");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MG2";
							attack.quest.mixtable_bottle = "MG2";

							if(pc == 1) RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
							TakeItemFromCharacter(attack, "pistolcopperas");

							LAi_QuestDelay("place_mixtable_item", 1.0);
							return;
						}
					}

					//HALF FULL BOTTLE: H2SO4
					if(CheckAttribute(attack, "quest.mixtable_bottle") && attack.quest.mixtable_bottle == "MT1_sulf")
					{
						if(CheckAttribute(weapon, "id") )
						{
							if(weapon.id == "pistolnitre")
							{
								PlaySound("PEOPLE\grass_noise.wav");
								locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT2_sulf_c";
								attack.quest.mixtable_bottle = "MT2_sulf_c";

								if(pn == 1) RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
								TakeItemFromCharacter(attack, "pistolnitre");

								LAi_QuestDelay("place_mixtable_item", 1.0);
								return;
							}

							if(weapon.id == "pistolsalt")
							{
								PlaySound("PEOPLE\grass_noise.wav");
								locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT2_hydr";
								attack.quest.mixtable_bottle = "MT2_hydr";

								if(ps == 1) RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
								TakeItemFromCharacter(attack, "pistolsalt");

								LAi_QuestDelay("place_mixtable_item", 1.0);
								return;
							}
						}
					}
				}
				return;
			}
		}
		else
		{
			if(attack.location == "wr_ships")
			{
				if(CheckAttribute(attack,"quest.deck_position") && attack.quest.deck_position == "mechanism_L")
				{
					if(CheckAttribute(weapon, "id") )
					{
						if(weapon.id == "pistolwheel")
						{
							//place wheel!
							PlaySound("INTERFACE\wheel_place.wav");
							RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
							TakeItemFromCharacter(attack, "pistolwheel");
							if(!CheckCharacterItem(attack,"pistolhand")) GiveItem2Character(attack,"pistolhand");
							EquipCharacterByItem(attack, "pistolhand");

							Locations[FindLocation("wr_ships")].models.always.l13 = "wheel_L";
							attack.quest.wheel_pos_left = "wheel";

							LAi_QuestDelay("at_mechanism_L", 0.5);
						}

						{
							if(weapon.id == "pistolhand")
							{
								//take wheel if any
								if(CheckAttribute(attack,"quest.wheel_pos_left") && attack.quest.wheel_pos_left == "wheel")
								{
									PlaySound("INTERFACE\wheel_take.wav");
									RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
									TakeItemFromCharacter(attack, "pistolhand");
									GiveItem2Character(attack,"pistolwheel");
									EquipCharacterByItem(attack, "pistolwheel");

									Locations[FindLocation("wr_ships")].models.always.l13 = "";
									attack.quest.wheel_pos_left = "free";

									LAi_QuestDelay("at_mechanism_L", 1.0);
								}
								else
								{
									//return?
								}
							}
						}
					}
					return;	//new
				}

				if(CheckAttribute(attack,"quest.deck_position") && attack.quest.deck_position == "mechanism_R")
				{
					if(CheckAttribute(weapon, "id") )
					{
						if(weapon.id == "pistolwheel")
						{
							//place wheel!
							PlaySound("INTERFACE\wheel_place.wav");
							RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
							TakeItemFromCharacter(attack, "pistolwheel");
							if(!CheckCharacterItem(attack,"pistolhand")) GiveItem2Character(attack,"pistolhand");
							EquipCharacterByItem(attack, "pistolhand");

							Locations[FindLocation("wr_ships")].models.always.l13 = "wheel_R";
							attack.quest.wheel_pos_right = "wheel";

							LAi_QuestDelay("at_mechanism_R", 0.5);
						}

						{
							if(weapon.id == "pistolhand")
							{
								//take wheel if any
								if(CheckAttribute(attack,"quest.wheel_pos_right") && attack.quest.wheel_pos_right == "wheel")
								{
									PlaySound("INTERFACE\wheel_take.wav");
									RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
									TakeItemFromCharacter(attack, "pistolhand");
									GiveItem2Character(attack,"pistolwheel");
									EquipCharacterByItem(attack, "pistolwheel");

									Locations[FindLocation("wr_ships")].models.always.l13 = "";
									attack.quest.wheel_pos_right = "free";

									LAi_QuestDelay("at_mechanism_R", 1.0);
								}
								else
								{
									//return?
								}
							}
						}
					}
					return;	//new
				}

				if(CheckAttribute(attack,"quest.deck_position") && attack.quest.deck_position == "elsewhere")
				{
					//no enemy no interesting station - do nothing
					return;	//new
				}
			}

			if(attack.location == "wr_corv_crew")
			{
				if(CheckAttribute(weapon, "id") && weapon.id == "pistolhand")
				{
					if(CheckAttribute(attack,"quest.tablemap") && attack.quest.tablemap == "on_floor")
					{
						PlaySound("INTERFACE\paper.wav");
						Locations[FindLocation("wr_corv_crew")].models.always.l2 = "doormap1";
						attack.quest.tablemap = "under_door";

						Locations[FindLocation("wr_corv_crew")].models.always.l3 = "";

						LAi_QuestDelay("use_gunitem_at_belt_door", 1.0);
						return;
					}

					if(CheckAttribute(attack,"quest.tablemap") && attack.quest.tablemap == "under_door")
					{
						PlaySound("INTERFACE\paper.wav");
						Locations[FindLocation("wr_corv_crew")].models.always.l2 = "floormap1";
						attack.quest.tablemap = "on_floor";

						if(CheckAttribute(attack,"quest.beltkey") && attack.quest.beltkey == "on_map")
						{
							Locations[FindLocation("wr_corv_crew")].models.always.l3 = "keysimple1";
						}
						else Locations[FindLocation("wr_corv_crew")].models.always.l3 = "";

						LAi_QuestDelay("use_gunitem_at_belt_door", 1.0);
						return;
					}
				}

				if(CheckAttribute(weapon, "id") && weapon.id == "pistolmap1")
				{
					PlaySound("INTERFACE\paper.wav");
					RemoveCharacterEquip(attack, GUN_ITEM_TYPE);
					TakeItemFromCharacter(attack, "pistolmap1");
					if(!CheckCharacterItem(attack,"pistolhand")) GiveItem2Character(attack,"pistolhand");
					EquipCharacterByItem(attack, "pistolhand");

					Locations[FindLocation("wr_corv_crew")].models.always.l2 = "floormap1";
					attack.quest.tablemap = "on_floor";

					LAi_QuestDelay("use_gunitem_at_belt_door", 1.0);
				}

				return;
			}
		}
		else
		{
			//JRH added for rifles when firing at nothing:

			if(IsMainCharacter(attack))
			{
				if(CheckAttribute(weapon,"model") && weapon.model == "musketoon")
				{
					attack.quest.mtoon_status = "unloaded";

					LAi_QuestDelay("place_mtoon_on_back", 2.0);
				}

				if(CheckAttribute(weapon,"model") && weapon.model == "musket")
				{
					attack.quest.mket_status = "unloaded";

					LAi_QuestDelay("place_mket_on_back", 2.0);
				}
			}

			return;
		}
	}
//<-- JRH

	// end of unchanged original code

	//skillearning(attack, "Fencing", 1);	// ccc skillearning

	// ccc special weapon assembly kit start
	// note: the function we are in here runs if a character (refered to as "attack") uses a gun AND has a targetcharacter ("enemy") in range

	/*
	//JRH moved this up
	string weaponID = GetCharacterEquipByGroup(attack,GUN_ITEM_TYPE);	// defines weaponname
	aref weapon;
	Items_FindItem(weaponID, &weapon);	// defines object for weaponattributes
	*/

	bool CheckHostile = true; // run LAi_Attacked etc. set-hostile code. NK 05-07-10
	bool SetHostile = true;
	string effects_to_play = "always"; // for selective playing of FX
	int i;

//================================================================================================
// JRH ammo mod --->

/*
//JRH moved this up
float u, v, w;          		// coordinates for effects, JRH misf mod
GetCharacterPos(attack, &u, &v, &w);    // determines position of initial target
*/

int gp;
int pb;
int pg;
int mb;

if (ENABLE_AMMOMOD == 1 )
{
    if(IsMainCharacter(attack) || IsOfficer(attack) ) // JRH fix oct 06: officer should consume ammo
    {
	//Log_SetStringToLog("PCHAR or OFFICER");

	if(GetCharacterIndex(attack.id)==GetMainCharacterIndex() && attack.location == "wr_ships")
	{
		if(CheckAttribute(attack,"quest.deck_position") && attack.quest.deck_position == "cannon")
		{
			ChangeCharacterAddressGroup(attack, "wr_ships", "goto", "fire");//if he's running away

			if(attack.quest.cannon_priming == "yes")
			{
				//LogIt("priming = yes");
				CreateParticleSystem("gunfire_red" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
				CreateParticleSystem("stars_fire" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
				PlaySound("OBJECTS\duel\GI_ValidClick.wav");

				attack.quest.cannon_priming = "no";
				//LogIt("cannon priming = " + attack.quest.cannon_priming);

				LAi_QuestDelay("guncrew_fire2", 0.5);
				return;
			}
			else
			{
				//LogIt("priming = no");
				LAi_SetPlayerType(attack);
				LAi_SetFightMode(attack, false);
				LAi_LocationFightDisable(&Locations[FindLocation("wr_ships")], true);
				return;
			}
		}

		if(CheckAttribute(attack,"quest.deck_position") && attack.quest.deck_position == "elsewhere")
		{
			LAi_SetPlayerType(attack);
			LAi_SetFightMode(attack, false);
			LAi_LocationFightDisable(&Locations[FindLocation("wr_ships")], true);
			return;		//just in case
		}
	}

	if(CheckAttribute(attack,"quest.wet_gp") && attack.quest.wet_gp == "yes")
	{
		weapon.misfunction22 = 100;
	}
	else weapon.misfunction22 = 0;

 	if(CheckAttribute(weapon, "shottype") && weapon.shottype == "pg2")
	{
		//for officers essentially
		if(IsOfficer(attack))
		{
			if(CheckAttribute(weapon,"model") && weapon.model == "musketoon_back")
			{
				PlaySound("OBJECTS\duel\reload1.wav");
				attack.chr_ai.charge = "1";

				LAi_QuestDelay("officer_rifle_check", 1.0);
				return;
			}
		}

		gp = GetCharacterItem(attack, "gunpowder");
 		pg = GetCharacterItem(attack, "pistolgrapes");
		if(gp >=2 && pg >= 2)
		{
			TakeNItems(attack,"gunpowder", -2);

			if(CheckAttribute(attack,"quest.wet_gp") && attack.quest.wet_gp == "yes")
			{
				//don't consume grapes
			}
			else TakeNItems(attack,"pistolgrapes", -2);	//shot!

			gp = GetCharacterItem(attack, "gunpowder");
			pg = GetCharacterItem(attack, "pistolgrapes");
			if(gp >=2 && pg >= 2)
			{
				//ok
			}
			else
			{
				if(IsMainCharacter(attack)) // JRH fix oct 06: moved back from LAi_fightparams
				{
					if(gp == 1) Log_SetStringToLog(TranslateString("","There is not enough Gunpowder"));
					if(pg == 1) Log_SetStringToLog(TranslateString("","There are not enough Grapeshots"));
					if(gp == 0) Log_SetStringToLog(TranslateString("","There is no Gunpowder left"));
					if(pg == 0) Log_SetStringToLog(TranslateString("","There are no Grapeshots left"));
				}
		        }
		}
		else
		{
			weapon.misfunction21 = 100;	//misf needed to avoid normal pistol sound
			if(IsMainCharacter(attack))
			{
				if(gp == 1) Log_SetStringToLog(TranslateString("","There is not enough Gunpowder"));
				if(pg == 1) Log_SetStringToLog(TranslateString("","There are not enough Grapeshots"));
				if(gp == 0) Log_SetStringToLog(TranslateString("","There is no Gunpowder left"));
				if(pg == 0) Log_SetStringToLog(TranslateString("","There are no Grapeshots left"));

			//JRH added for rifles when 'firing' at enemy without enough ammo:
				if(CheckAttribute(weapon,"model") && weapon.model == "musketoon")
				{
					attack.quest.mtoon_status = "unloaded";

					LAi_QuestDelay("place_mtoon_on_back", 2.0);
				}
			//<-- JRH added for rifles when 'firing' at enemy without enough ammo
			}
		}
	}
	else
	{
	   if(CheckAttribute(weapon, "shottype") && weapon.shottype == "mb")
	   {
		gp = GetCharacterItem(attack, "gunpowder");
		mb = GetCharacterItem(attack, "musketbullets");

		//for officers essentially
		if(IsOfficer(attack))
		{
			if(CheckAttribute(weapon,"model") && weapon.model == "musket_back")
			{
				PlaySound("OBJECTS\duel\reload1.wav");
				attack.chr_ai.charge = "1";

				LAi_QuestDelay("officer_rifle_check", 1.0);
				return;
			}
		}

		if(gp >=2 && mb >= 1)
		{
			TakeNItems(attack,"gunpowder", -2);

			if(CheckAttribute(attack,"quest.wet_gp") && attack.quest.wet_gp == "yes")
			{
				//don't consume bullets
			}
			else TakeNItems(attack,"musketbullets", -1);

			gp = GetCharacterItem(attack, "gunpowder");
			mb = GetCharacterItem(attack, "musketbullets");
			if(gp >=2 && mb >= 1)
			{
				//ok
			}
			else
			{
				if(IsMainCharacter(attack))
				{
					if(gp == 1) Log_SetStringToLog(TranslateString("","There is not enough Gunpowder"));
					if(gp == 0) Log_SetStringToLog(TranslateString("","There is no Gunpowder left"));
					if(mb == 0) Log_SetStringToLog(TranslateString("","There are no Musketbullets left"));
				}
		        }
		}
		else
		{
			weapon.misfunction21 = 100;	//misf needed to avoid normal pistol sound
			if(IsMainCharacter(attack))
			{
				if(gp == 1) Log_SetStringToLog(TranslateString("","There is not enough Gunpowder"));
				if(gp == 0) Log_SetStringToLog(TranslateString("","There is no Gunpowder left"));
				if(mb == 0) Log_SetStringToLog(TranslateString("","There are no Musketbullets left"));

			//JRH added for rifles when 'firing' at enemy without enough ammo -->
				if(CheckAttribute(weapon,"model") && weapon.model == "musket")
				{
					attack.quest.mket_status = "unloaded";

					LAi_QuestDelay("place_mket_on_back", 2.0);
				}
			//<-- JRH added for rifles when 'firing' at enemy without enough ammo
			}
		}
	   }
	}
	else
	{
	   if(CheckAttribute(weapon, "shottype") && weapon.shottype == "pg")
	   {
		gp = GetCharacterItem(attack, "gunpowder");
		pg = GetCharacterItem(attack, "pistolgrapes");
		if(gp >= 1 && pg >= 1)
		{
			TakeNItems(attack,"gunpowder", -1);

			if(CheckAttribute(attack,"quest.wet_gp") && attack.quest.wet_gp == "yes")
			{
				//don't consume grapes
			}
			else TakeNItems(attack,"pistolgrapes", -1);	//shot!

			gp = GetCharacterItem(attack, "gunpowder");
			pg = GetCharacterItem(attack, "pistolgrapes");
			if(gp >= 1 && pg >= 1)
			{
				//ok
			}
			else
			{
				if(IsMainCharacter(attack))
				{
					if(gp == 0) Log_SetStringToLog(TranslateString("","There is no Gunpowder left"));
					if(pg == 0) Log_SetStringToLog(TranslateString("","There are no Grapeshots left"));
				}
		        }
		}
		else
		{
			weapon.misfunction21 = 100;	//misf needed to avoid normal pistol sound
			if(IsMainCharacter(attack))
			{
				if(gp == 0) Log_SetStringToLog(TranslateString("","There is no Gunpowder left"));
				if(pg == 0) Log_SetStringToLog(TranslateString("","There are no Grapeshots left"));
			}
		}
	   }
	}
	else
	{
	   if(CheckAttribute(weapon, "shottype") && weapon.shottype == "pb")
	   {
		gp = GetCharacterItem(attack, "gunpowder");
		pb = GetCharacterItem(attack, "pistolbullets");
		if(gp >= 1 && pb >= 1)
		{
			if(CheckAttribute(weapon, "id") && weapon.id == "pistoltinderbox")
			{
				CreateParticleSystem("gunfire_red" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
				CreateParticleSystem("stars_fire" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
				PlaySound("OBJECTS\duel\GI_ValidClick.wav");

				LAi_QuestDelay("tinder_box", 1.0);
				return;
			}

			TakeNItems(attack,"gunpowder", -1);

			if(CheckAttribute(attack,"quest.wet_gp") && attack.quest.wet_gp == "yes")
			{
				//don't consume bullets
			}
			else TakeNItems(attack,"pistolbullets", -1);	//shot!

			gp = GetCharacterItem(attack, "gunpowder");
			pb = GetCharacterItem(attack, "pistolbullets");
			if(gp >= 1 && pb >= 1)
			{
				//ok
			}
			else
			{
				if(IsMainCharacter(attack))
				{
					if(gp == 0) Log_SetStringToLog(TranslateString("","There is no Gunpowder left"));
					if(pb == 0) Log_SetStringToLog(TranslateString("","There are no Pistolbullets left"));
				}
		        }
		}
		else
		{
			weapon.misfunction21 = 100;	//misf needed to avoid normal pistol sound
			if(IsMainCharacter(attack))
			{
				if(gp == 0) Log_SetStringToLog(TranslateString("","There is no Gunpowder left"));
				if(pb == 0) Log_SetStringToLog(TranslateString("","There are no Pistolbullets left"));
			}
		}
	   }
	}
    }
    else
    {
    //JRH added for NPC:s rifles -->
	if(CheckAttribute(weapon,"model") && weapon.model == "musketoon_back")
	{
		PlaySound("OBJECTS\duel\reload1.wav");
		return;
	}

	if(CheckAttribute(weapon,"model") && weapon.model == "musket_back")
	{
		PlaySound("OBJECTS\duel\reload1.wav");
		return;
	}
    //<-- JRH added for NPC:s rifles
    }
}

	//click-shot, normally this will NOT show up, just in case
	//gun will not reload if gp or shot = 0 see LAi_fightparams & Character_utilite
	//mtoon & musket with not ENOUGH ammo will give a click-shot, and that is only if inventory is opened
	if(CheckAttribute(weapon, "misfunction21") && rand(100)<sti(weapon.misfunction21) )
	{
		CreateParticleSystem("gunfire_red" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
		CreateParticleSystem("stars_fire" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );
		LAi_CharacterPlaySound(attack, "OBJECTS\duel\GI_ValidClick.wav");//MAXIMUS

		weapon.misfunction21 = 0;

		//LanguageCloseFile(tmpLangFileID);
		return;
	}

// JRH ammo mod <---
//================================================================================================
 //JRH switch model & sound pistol20 (BB6) -->
	if(CheckAttribute(weapon, "id") && weapon.id == "pistol20")
	{
		if(CheckAttribute(weapon, "change") && weapon.change == 7 )
		{
			attack.chr_ai.charge = "6";
			attack.chr_ai.chargeprc = "0";//was 0
			weapon.change = 1;
		}

		if(CheckAttribute(weapon, "change") && weapon.change == 6 )
		{
			if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
			{
				weapon.dmg_min = 0.0;
        			weapon.dmg_max = 0.0;
        			weapon.accuracy = 0;
			}
			else
			{
				weapon.dmg_min = 65.0;
        			weapon.dmg_max = 85.0;
        			weapon.accuracy = 75;
				PlaySound("OBJECTS\DUEL\pistol_musket.wav");
			}

			if(gp == 0 || pb == 0)
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol201_w";
				}
				else weapon.model = "pistol201";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "0";
				attack.chr_ai.chargeprc = "1";	//only one "1"
				weapon.change = 7;
			}
			else
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol201_w";
				}
				else weapon.model = "pistol201";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "0";
				attack.chr_ai.chargeprc = "1";
				weapon.change = 7;
			}
		}

		if(CheckAttribute(weapon, "change") && weapon.change == 5 )
		{
			if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
			{
				weapon.dmg_min = 0.0;
        			weapon.dmg_max = 0.0;
        			weapon.accuracy = 0;
			}
			else
			{
				weapon.dmg_min = 50.0;
        			weapon.dmg_max = 67.5;
        			weapon.accuracy = 60;
				PlaySound("OBJECTS\duel\pistol_medium2.wav");
			}

			if(gp == 0 || pb == 0)
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol201_w";
				}
				else weapon.model = "pistol201";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "0";
				attack.chr_ai.chargeprc = "1";	//only one "1"
				weapon.change = 7;
			}
			else
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol206_w";
				}
				else weapon.model = "pistol206";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "1";
				attack.chr_ai.chargeprc = "0";
				weapon.change = 6;
			}
		}

		if(CheckAttribute(weapon, "change") && weapon.change == 4 )
		{
			if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
			{
				weapon.dmg_min = 0.0;
        			weapon.dmg_max = 0.0;
        			weapon.accuracy = 0;
			}
			else
			{
				weapon.dmg_min = 40.0;
        			weapon.dmg_max = 55.0;
        			weapon.accuracy = 50;
				PlaySound("OBJECTS\duel\pistol_grape2.wav");
			}

			if(gp == 0 || pb == 0)
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol201_w";
				}
				else weapon.model = "pistol201";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "0";
				attack.chr_ai.chargeprc = "1";	//only one "1"
				weapon.change = 7;
			}
			else
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol205_w";
				}
				else weapon.model = "pistol205";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "2";
				attack.chr_ai.chargeprc = "0";
				weapon.change = 5;
			}
		}

		if(CheckAttribute(weapon, "change") && weapon.change == 3 )
		{
			if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
			{
				weapon.dmg_min = 0.0;
        			weapon.dmg_max = 0.0;
        			weapon.accuracy = 0;
			}
			else
			{
				weapon.dmg_min = 60.0;
        			weapon.dmg_max = 80.0;
        			weapon.accuracy = 70;
				PlaySound("OBJECTS\duel\pistol_big2.wav");
			}

			if(gp == 0 || pb == 0)
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol201_w";
				}
				else weapon.model = "pistol201";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "0";
				attack.chr_ai.chargeprc = "1";	//only one "1"
				weapon.change = 7;
			}
			else
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol204_w";
				}
				else weapon.model = "pistol204";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "3";
				attack.chr_ai.chargeprc = "0";
				weapon.change = 4;
			}
		}

		if(CheckAttribute(weapon, "change") && weapon.change == 2 )
		{
			if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
			{
				weapon.dmg_min = 0.0;
        			weapon.dmg_max = 0.0;
        			weapon.accuracy = 0;
			}
			else
			{
				weapon.dmg_min = 35.0;
        			weapon.dmg_max = 50.0;
        			weapon.accuracy = 40;
				PlaySound("OBJECTS\duel\pistol_small2.wav");
			}

			if(gp == 0 || pb == 0)
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol201_w";
				}
				else weapon.model = "pistol201";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "0";
				attack.chr_ai.chargeprc = "1";	//only one "1"
				weapon.change = 7;
			}
			else
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol203_w";
				}
				else weapon.model = "pistol203";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "4";
				attack.chr_ai.chargeprc = "0";
				weapon.change = 3;
			}
		}

		if(CheckAttribute(weapon, "change") && weapon.change == 1 )
		{
			if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
			{
				weapon.dmg_min = 0.0;
        			weapon.dmg_max = 0.0;
        			weapon.accuracy = 0;
			}
			else
			{
				weapon.dmg_min = 50.0;
        			weapon.dmg_max = 67.5;
        			weapon.accuracy = 60;
				PlaySound("OBJECTS\duel\pistol_medium3.wav");
			}

			if(gp == 0 || pb == 0)
			{
				attack.chr_ai.charge = "0";
				attack.chr_ai.chargeprc = "1";	//only one "1"
				weapon.change = 7;
			}
			else
			{
				if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
				{
					weapon.model = "pistol202_w";
				}
				else weapon.model = "pistol202";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, weaponID);

				attack.chr_ai.charge = "5";
				attack.chr_ai.chargeprc = "0";
				weapon.change = 2;
			}
		}
	}
   //<--JRH

   //JRH wet gunpowder -->
	if(CheckAttribute(weapon, "misfunction22") && weapon.misfunction22 == 100 )
	{
		Log_SetStringToLog("Gunpowder must be wet!");
		PlaySound("OBJECTS\duel\wet_gunpowder.wav");
		CreateParticleSystem("gunfire_black" , u, v+1.5, w, 0.0, 0.0, 0.0, sti(20) );

		//LogIt("misf 12 = " + weapon.misfunction12);
		return;
	}
   //<--JRH

   //JRH switch model trowing pistols -->
	if(CheckAttribute(weapon, "id") && weapon.id == "pistolthrow1")
	{
		RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
		TakeItemFromCharacter(attack, "pistolthrow1");
		GiveItem2Character(attack, "pistolbelt");
		EquipCharacterByItem(attack, "pistolbelt");
		GiveItem2Character(enemy, "pistol206");
	}

	if(CheckAttribute(weapon, "id") && weapon.id == "pistolthrow2")
	{
		RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
		TakeItemFromCharacter(attack, "pistolthrow2");
		GiveItem2Character(attack, "pistolthrow1");
		EquipCharacterByItem(attack, "pistolthrow1");
		GiveItem2Character(enemy, "pistol205");
	}

	if(CheckAttribute(weapon, "id") && weapon.id == "pistolthrow3")
	{
		RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
		TakeItemFromCharacter(attack, "pistolthrow3");
		GiveItem2Character(attack, "pistolthrow2");
		EquipCharacterByItem(attack, "pistolthrow2");
		GiveItem2Character(enemy, "pistol204");
	}

	if(CheckAttribute(weapon, "id") && weapon.id == "pistolthrow4")
	{
		RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
		TakeItemFromCharacter(attack, "pistolthrow4");
		GiveItem2Character(attack, "pistolthrow3");
		EquipCharacterByItem(attack, "pistolthrow3");
		GiveItem2Character(enemy, "pistol202");
	}

	if(CheckAttribute(weapon, "id") && weapon.id == "pistolthrow5")
	{
		RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
		TakeItemFromCharacter(attack, "pistolthrow5");
		GiveItem2Character(attack, "pistolthrow4");
		EquipCharacterByItem(attack, "pistolthrow4");
		GiveItem2Character(enemy, "pistol201");
	}
    //<-- JRH
//================================================================================================
	if(CheckAttribute(weapon, "misfire") && rand(100)<sti(weapon.misfire) )
		// if a weapon can misfire & chance for that, as defined in items\itemsinit.c
	{
		Log_SetStringToLog(TranslateString("","Weapon misfired & blew up !"));
		Explosion (attack, rand(20));			// New "explosion" function hurts weaponuser
  		if(GetCharacterItem(attack, weaponID) <= 1) RemoveCharacterEquip(attack, weapon.groupID);	// unequips thrown weapon
               	TakeItemFromCharacter(attack, weaponID );	// deletes exploded weapon from inventory
		LAi_CharacterPlaySound(attack, "OBJECTS\duel\sword_fallen.wav");//MAXIMUS
		//LanguageCloseFile(tmpLangFileID);
		return;
	}

	if( CheckAttribute(weapon, "sound" ) )
	{
		/*
		if(IsMainCharacter(attack))
		{
			PlaySound( weapon.sound ); //JRH: louder if Pchar
		}
		else LAi_CharacterPlaySound(attack, weapon.sound); //MAXIMUS: plays soundfile if defined in items\itemsinit.c
		*/

		PlaySound( weapon.sound ); //JRH: louder for all gives more action!
	} else {
		if(CheckAttribute(weapon, "id") && weapon.id != "pistol20")	//JRH: not for this one!
		{
			LAi_CharacterPlaySound(attack, "OBJECTS\duel\pistol_shot2.wav"); //MAXIMUS: otherwise normal pistolsound
		}
	}

	int damagetoapply = 0;
	if( CheckAttribute(weapon, "multidmg" ) )	// next section runs only if chr near target shall be hurt
	{
		int num = FindNearCharacters(enemy, 2.5, -1.0, -1.0, 0.001, false, true);
			// checks if there are other people around the initial target. 2.5 is the checkradius

		//for(int j = 0; j <= num; j++)	// LDH no wonder this was getting people who weren't near: it included an extra character!
		for (int j = 0; j < num; j++)	// the following loop runs for each near character	// LDH fixed <=num - 08May09
		{
			int idx = -1;// MAXIMUS [fix for CheckAttribute]
			if(CheckAttribute(chrFindNearCharacters[j],"index")) idx = sti(chrFindNearCharacters[j].index);	// defines near character as idx
			if(idx == -1) continue;
			ref findCh;
			findCh = GetCharacter(idx);	// necessary? to get object for next line

			LAi_ApplyCharacterFireDamage(attack, &Characters[idx], kDist );
				// applies normal gunfire damage to near characters EXCEPT user & officers!

			if( CheckAttribute(weapon, "selfdmg" ) && findCh.id==attack.id)	// if user shall be hurt if too close
			{
				LAi_ApplyCharacterDamage( &Characters[idx], sti(weapon.dmg_min) );
					// applies minimumdamage of weapon to every near character, i.e. user also

				if(stf(attack.chr_ai.hp) < 1.0) attack.chr_ai.hp = 1 + makeint(rand(10));
					// jun05 so you dont kill yourself

				// LAi_CheckKillCharacter( &Characters[idx] );
					// checks if this has killed the character
			}

			if(CheckAttribute(weapon, "stun")&&!LAi_IsFightMode(&Characters[idx])&&findCh.chr_ai.group!=LAI_GROUP_PLAYER)
			 	// if weapon stuns victim; works only if victim is not prepared for fight and no playerassociate
			{
				int tduration = 100;
				if(CheckAttribute(weapon, "stun.duration")) tduration = sti(weapon.stun.duration);
				//MAXIMUS: during fight, character can join to his crew. Sometimes it may be helpful -->
				bool bPlayer = false;
				ref mainCh = GetMainCharacter();
				if(CheckAttribute(&findCh, "chr_ai.group") && findCh.chr_ai.group==LAI_GROUP_PLAYER)
				{
					if(sti(mainCh.skill.Leadership)>sti(findCh.skill.Leadership)) bPlayer = true;
				}
				else
				{
					if(sti(mainCh.skill.Leadership)<sti(findCh.skill.Leadership)) bPlayer = true;
				}
				LAi_Stunned_StunCharacter(&findCh, tduration, true, STUN_STARS, bPlayer);
				//MAXIMUS: during fight, character can join to his crew. Sometimes it may be helpful <--
			}

			if( CheckAttribute(weapon, "poison" ) ) 	// if weapon poisonous
			{
				findCh.chr_ai.poison =  300 ;	// poisons EVERY near character
				// NK play sound too 05-07-10
				if(findCh.sex == "woman") {LAi_CharacterPlaySound(findCh, "OBJECTS\Voices\dead\female\dead_wom2.wav");}	// groan
				else{LAi_CharacterPlaySound(findCh, "OBJECTS\Voices\dead\male\dead4.wav");}
			}

		}	// end of loop
		// NK do this below for GFX support
		damagetoapply = sti(weapon.dmg_min);
		/*LAi_ApplyCharacterDamage( enemy, sti(weapon.dmg_min) );
			// to ensure that initial target suffers minimumdamage, wasn't always the case
		LAi_CheckKillCharacter( enemy );
			// checks if this has killed the character*/

	}	// end of multidamage section

	if( CheckAttribute(weapon, "steal" ) && !LAi_IsFightMode(enemy) )
	 	// if weapon is a thief's tool; works only if victim is not prepared for fight
	{

		//skillearning(attack, "sneak", 1);	// ccc skillearning
		CheckHostile = false;
		LAi_AttemptSteal(attack, enemy, weapon); // NK do this in one function. 05-07-10
	}

	if( CheckAttribute(weapon, "stun" ) && !LAi_IsFightMode(enemy) && enemy.chr_ai.group != LAI_GROUP_PLAYER )
	 	// if weapon stuns victim; works only if victim is not prepared for fight and no playerassociate
	{

		//skillearning(attack, "sneak", 1);	// ccc skillearning
		if(frnd() < stf(weapon.stun)*GetAttackLuckMod(&attack))	// jun 05 stun doesnt work always anymore
		{
			int duration = 100;
			if(CheckAttribute(weapon, "stun.duration")) duration = sti(weapon.stun.duration);
				//MAXIMUS: during fight, character can join to his crew. Sometimes it may be helpful -->
				bPlayer = false;
				if(CheckAttribute(enemy, "chr_ai.group") && enemy.chr_ai.group==LAI_GROUP_PLAYER)
				{
					if(sti(mainCh.skill.Leadership)>sti(enemy.skill.Leadership)) bPlayer = true;
				}
				else
				{
					if(sti(mainCh.skill.Leadership)<sti(enemy.skill.Leadership)) bPlayer = true;
				}
				LAi_Stunned_StunCharacter(enemy, duration, true, STUN_STARS, bPlayer);
				//MAXIMUS: during fight, character can join to his crew. Sometimes it may be helpful <--
			//effects_to_play += " stun";
		}
	}

	if( CheckAttribute(weapon, "poison" ) ) 	// if weapon poisonous
	{
		enemy.chr_ai.poison =  300 ;		// initial targetchr poisoned
		if(enemy.sex == "man") {LAi_CharacterPlaySound(enemy, "OBJECTS\Voices\dead\male\dead4.wav");}	// groan
		else{LAi_CharacterPlaySound(enemy, "OBJECTS\Voices\dead\female\dead_wom2.wav");}
		if(!CheckAttribute(weapon, "selfdmg" ) )	// if user shall NOT ! be hurt if too close
		{ attack.chr_ai.poison = 0 ;}			// "UNpoisons" the user in this case
			// this may in rare cases heal the user from another poisoning, but I doubt that's a problem
			effects_to_play += " poison";
	}

	if(CheckHostile)
	{
		if(CheckAttribute(weapon, "stealth"))	// silent weapons don't alarm the victim, for others next line runs
		{
	          	if(frnd() < stf(weapon.stealth)*GetAttackLuckMod(&attack)) { SetHostile = false; }
			//MAXIMUS -->
			else
			{
				if(enemy.sex=="woman") LAi_CharacterPlaySound(enemy, "VOICE\" + LanguageGetLanguage() + "\Eng_f_c_001.wav");//woman voice - "Help, help me, please. I adjure..."
				else LAi_CharacterPlaySound(enemy, "VOICE\" + LanguageGetLanguage() + "\Fre_m_c_038.wav");//man voice - "Stay here! Who are you?"
			}
			PlaySound("AMBIENT\TOWN\Alarm.wav");
			//MAXIMUS <--
//			else { PlaySound("VOICE\" + LanguageGetLanguage() + "\Eng_m_a_067.wav"); } // sound alarm
		}
	}
	else SetHostile = false;

	if( CheckAttribute(weapon, "throw" ) && charge <= 1.0 )	// for weapons that you throw, so only onetime use
	{
			if(GetCharacterItem(attack, weaponID) <= 1) RemoveCharacterEquip(attack, weapon.groupID);	// unequips thrown weapon
			TakeItemFromCharacter(attack, weaponID );		// deletes thrown weapon from inventory
	}

	//   
	// ccc LAi_group_Attack(attack, enemy);	// line moved into "stealth" section

	// ccc particle effects, runs only if effect defined  in inititems.c
	LAi_PlayHitGFX(attack, enemy, weapon, effects_to_play); // NK do in centralized function 05-07-10


	// 
	//jul 05 tools don't do damage. NK multidmg to target chr still is done, but is done direct, not with firedamage
	if( !CheckAttribute(weapon, "multidmg" )&&!CheckAttribute(weapon, "tool") ) { LAi_ApplyCharacterFireDamage(attack, enemy, kDist); }
	else // NK except we need to apply multidmg to the target chr _after_ the GFX or the GFX won't have a character to get position from.
	{
		if(damagetoapply > 0) // i.e. is multidmg after all
		{
			LAi_ApplyCharacterDamage( enemy, damagetoapply );
			// to ensure that initial target suffers minimumdamage, wasn't always the case

			// ccc sep05, keeps player & officers barely alive
			if(stf(enemy.chr_ai.hp)<1.0 && enemy.chr_ai.group==LAI_GROUP_PLAYER) enemy.chr_ai.hp = MIN_GUNATTACK_HP;

			LAi_CheckKillCharacter( enemy );
			// checks if this has killed the character
		}
	}

	if(SetHostile) // if we are setting enemy hostile to us (and haven't yet)
	{
		if(!LAi_IsDead(enemy)) { LAi_group_Attack(attack, enemy); } // if not dead, alarm!
		else // otherwise...
		{
			// for now, just behave like normal. When I have a chance, I'll check near characters vs. see/hear radius.
			//int num = FindNearCharacters(enemy, float rad, float ax, float testAng, float nearDist, bool isVisibleTest, bool isSort)
			LAi_group_Attack(attack, enemy);
		}
	}
	// ccc special weapon assembly kit end

	if(LAi_IsDead(enemy) && CheckAttribute(enemy,"itemtrade"))
	//if you killed a merchant
	{
		Logit(TranslateString("","The Merchantguild's watchmen are very vigilant..."));
		Ambush("guards", 4, "enemy", "friend",""); // 4 cops attack you
	}
	//LanguageCloseFile(tmpLangFileID);

	// unchanged code begins:

	// 
	string func = attack.chr_ai.type;
	if(func == "") return;
	func = "LAi_type_" + func + "_Fire";
	call func(attack, enemy, kDist, isFindedEnemy != 0);
	//  
	LAi_group_UpdateTargets(enemy);
	func = enemy.chr_ai.type;
	if(func == "") return;
	func = "LAi_type_" + func + "_Attacked";
	call func(enemy, attack);
	func = "LAi_type_" + enemy.chr_ai.type + "_CharacterUpdate";
	call func(enemy, 0.0001);

	//JRH switch rifles -->
	if(IsMainCharacter(attack))
	{
		if(CheckAttribute(weapon,"model") && weapon.model == "musketoon")
		{
			if(charge <= 0.0) attack.quest.mtoon_status = "unloaded";

			LAi_QuestDelay("place_mtoon_on_back", 2.0);
		}

		if(CheckAttribute(weapon,"model") && weapon.model == "musket")
		{
			if(charge <= 0.0) attack.quest.mket_status = "unloaded";

			LAi_QuestDelay("place_mket_on_back", 2.0);
		}
	}
	else
	{
		if(IsEquipCharacterByItem(attack, "pistolmtoon"))
		{
			if(CheckAttribute(weapon,"model") && weapon.model == "musketoon")
			{
				weapon.model = "musketoon_back";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, "pistolmtoon");
				attack.chr_ai.charge = "0";
				//attack.chr_ai.chargeprc = "0";
				attack.quest.rifle_recently_fired = "yes";

			//	if(IsOfficer(attack))
			//	{
			//		Log_SetStringToLog("OFFICER BACK SHOT!");
			//	}
			//	else Log_SetStringToLog("ENEMY mtoon BACK SHOT!");


				LAi_QuestDelay("rifle_recently_fired_delay", 2.0);
			}
		}

		if(IsEquipCharacterByItem(attack, "pistolmket"))
		{
			if(CheckAttribute(weapon,"model") && weapon.model == "musket")
			{
				weapon.model = "musket_back";
				RemoveCharacterEquip(attack, GUN_ITEM_TYPE );
				EquipCharacterByItem(attack, "pistolmket");
				attack.chr_ai.charge = "0";
				//attack.chr_ai.chargeprc = "0";
				attack.quest.rifle_recently_fired = "yes";

			//	if(IsOfficer(attack))
			//	{
			//		Log_SetStringToLog("OFFICER BACK SHOT!");
			//	}
			//	else Log_SetStringToLog("ENEMY mket BACK SHOT!");


				LAi_QuestDelay("rifle_recently_fired_delay", 2.0);
			}
		}
	}
	//<--- JRH switch rifles

	LAi_QuestDelay("pistol20_ammo_check", 0.1);		//JRH: see quest_reaction
}


bool LAi_tmp_return_bool;
bool LAi_CharacterIsFire()
{
	aref chr = GetEventData();
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//
	func = "LAi_tmpl_" + func + "_IsFire";
	LAi_tmp_return_bool = call func(chr);
	return LAi_tmp_return_bool;
}

bool LAi_CharacterIsFight()
{
	aref chr = GetEventData();
	string func = chr.chr_ai.tmpl;
	if(func == "") return true; // KK
	//
	func = "LAi_tmpl_" + func + "_IsFight";
	LAi_tmp_return_bool = call func(chr);
	return LAi_tmp_return_bool;
}

//==========================================================================================
//Escape events
//==========================================================================================

void LAi_CharacterEscapeSlide()
{
	//
	string endTask = GetEventData();
	aref chr = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterEscapeSlide") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//
	func = "LAi_tmpl_" + func + "_EscapeSlide";
	call func(chr);
}

//==========================================================================================
//Collision events
//==========================================================================================

void LAi_CharacterColThreshold()
{
	//
	string endTask = GetEventData();
	aref chr = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_CharacterColThreshold") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//
	func = "LAi_tmpl_" + func + "_ColThreshold";
	call func(chr);
}

//==========================================================================================
//Animation events
//==========================================================================================

void LAi_Character_EndAction()
{
	//
	aref chr = GetEventData();
	if(LAi_CheckCharacter(chr, "LAi_Character_EndAction") == false) return;
	string func = chr.chr_ai.tmpl;
	if(func == "") return;
	//
	func = "LAi_tmpl_" + func + "_EndAction";
	call func(chr);
}


//==========================================================================================
//Dead event
//==========================================================================================

void LAi_Character_Dead_Process(aref chr)
{
	// PB: Blade Damage mod
	if(!IsMainCharacter(chr) && FindCharacterItemByGroup(chr, "bladeX4")) TakeItemFromCharacter(chr, "bladeX4");

// ccc building kit aug05 ; deletes "killed" buildings from location
	if(CheckAttribute(chr,"chr_ai.type") && chr.chr_ai.type == "Building") // TIH
	{
		ref lcn = &Locations[FindLocation(chr.location)];	// determines where you are
		Building_delete(lcn, chr.lastname);

		// demolition effects
		float x, y, z;			// coordinates for effects...
		//get deathsite coords(the current coords of logoffed chr are different!)
		x=stf(chr.deathx);
		y=stf(chr.deathy);
		z=stf(chr.deathz);

		CreateParticleSystemX("blast_inv", x, y, z, x, y, z,0);	// effects at that pos
		CreateParticleSystemX("cancloud", x, y, z, x, y, z,20);
		CreateParticleSystemX("cancloud", x+5, y, z, x, y, z,20);
		CreateParticleSystemX("cancloud", x-5, y, z, x, y, z,20);
		CreateParticleSystemX("cancloud", x, y, z+5, x, y, z,20);
		CreateParticleSystemX("cancloud", x, y, z-5, x, y, z,20);

		PlaySound("OBJECTS\shipcharge\mast_fall3.wav");
		PlaySound("OBJECTS\shipcharge\hit_torock.wav");
	}
// ccc building kit end

// added by MAXIMUS [fix for Player dialog closed after anyone is dead] -->
	int tmpi = SendMessage(GetMainCharacter(),"ls",MSG_CHARACTER_EX_MSG,"FindDialogCharacter");
	if(CheckAttribute(chr,"index") && tmpi==sti(chr.index)) DialogExit();
// added by MAXIMUS [fix for Player dialog closed after anyone is dead] <--

	DeleteAttribute(chr, "donotshowXP"); // NK so XP is shown next time.
	// move logoff into if(), CORPSEMODE dependent.
	if(!IsMainCharacter(chr)) // MAXIMUS
	{
		//SCREWFACE : if a permanent crewmember is killed, his corpse disapear immediatly (don't remove that unless that will cause a bug)
		if(CORPSEMODE == 3 && !LAi_DoCORPEMODE(chr)) // NK persist original corpse 05-07-19 //GO Add Test for Quest that doesn't work with CORPSEMODE=3
		{
			LAi_GenerateFantomFromMe(chr);
			SetCharacterTask_Stay(chr);
			//PopCharacterTask(GetCharacter(sti(chr.index)));
			LAi_Stunned_MakeCorpse(chr);
			LAi_SetImmortal(chr, true);
		}
		else
		{
			if(CORPSEMODE!=2 && CORPSEMODE!=4 && !CheckAttribute(chr,"CORPSEMODE"))
			{//MAXIMUS: so, Maltese-corpse will always be lootable
				if(CheckAttribute(chr,"dialog.filename"))
				{
					if(chr.dialog.filename=="monk_dialog.c" || chr.dialog.filename=="Maltese_corpse_dialog.c") chr.CORPSEMODE = 4;
				}
			}
			int bCorpseMode = CORPSEMODE;
			if(CheckAttribute(chr,"CORPSEMODE") && sti(chr.CORPSEMODE)==4) bCorpseMode = 4;
			if(bCorpseMode<4 || CheckAttribute(chr,"makelocator")) { LAi_CharacterLogoff(chr); } //MAXIMUS: makes box from corpse with hand-icon in the top-left corner
			if(bCorpseMode==0) PostEvent("LAi_event_Character_Dead", 100, "l", sti(chr.index)); // MAXIMUS: corpse disappear
			else
			{
				PostEvent("LAi_event_Character_Dead", 500, "l", sti(chr.index)); // ccc jul05 corpse, time chg from 10000. NK change to 500. Make part of corpsemode != 3. // KK
			}
		}
		// NK do this in DeadEvent below: 05-07-13 - LAi_GenerateFantomFromMe(chr);
		LAi_group_CheckGroupQuest(chr);
	}
	else
	{
		LAi_CharacterLogoff(chr);
// KK -->
		if (!LAi_IsBoardingProcess()) {
			PostEvent("LAi_event_GameOver", 5000, "s", "land");
		} else {
			if (bMutinyDeckStarted)
				PostEvent("LAi_event_GameOver", 5000, "s", "mutiny");
			else
				PostEvent("LAi_event_GameOver", 5000, "s", "boarding");
		}
// <-- KK
	}
}

#event_handler("LAi_event_Character_Dead", "LAi_Character_Dead_Event");
void LAi_Character_Dead_Event() // should never be run when CORPSEMODE == 3. NK 05-07-19
{
	int chridx = GetEventData(); // KK
	if (chridx < 0) return; // KK

	int tmpNameFileID = LanguageOpenFile("characters_names.txt");

	ref chr = GetCharacter(chridx); // KK

// changed by MAXIMUS 12.10.2006 -->
	bool bLoc = CheckAttribute(chr,"location")==true;
	ref lcn;
	if(bLoc) lcn = &Locations[FindLocation(chr.location)];	// determines where you are
// changed by MAXIMUS 12.10.2006 <--

	// TIH --> changed behavior Sep2'06
	bool DissolveBody = true;
	int bCorpseMode = CORPSEMODE;
	if(CheckAttribute(chr,"CORPSEMODE") && sti(chr.CORPSEMODE)==4) bCorpseMode = 4;

	if(bCorpseMode==1 || bCorpseMode==4) DissolveBody = false;//MAXIMUS
	if(LAi_IsBoardingProcess()==true && AUTOLOOT_BOARDINGS) DissolveBody = false;//MAXIMUS: excludes player's decks
// changed by MAXIMUS 12.10.2006 -->
	if(bLoc)
	{
		if(CheckAttribute(lcn, "abbey") == true && sti(lcn.abbey) == true && bCorpseMode<4)		DissolveBody = true; // TIH for maltese knight abbey // KK
		if(CheckAttribute(chr,"chr_ai.type") && chr.chr_ai.type == "Building")					DissolveBody = true; // PB: For BuildingSet characters
	}
// changed by MAXIMUS 12.10.2006 <--

	if (DissolveBody)
	{
		CharacterExitFromLocation(chr);
	}
	else
	{
		// we wont be clearing the old body nor making a new body, so we need to keep this one around
		// however we set it as a neutral entity so that the warning indicator will go out when all enemies are dead
		if(bCorpseMode<4)
		{
			LAi_group_MoveCharacter(chr, LAI_GROUP_CORPSES);
		}
		if(bCorpseMode<4 || CheckAttribute(chr,"makelocator")) { LAi_CharacterLogoff(chr); }//MAXIMUS
	}
	// TIH <--

	// original chr body disappears, put 'if(chr.name != "The late")' in front to keep corpses lying around after looting
	// ccc jul05 corpse for looting

// KK -->
	/*if (!CheckAttribute(chr, "name"))		// LDH added to prevent errors on dead captains
	{
		Trace("Warning: Invalid character in LAi_CharacterDeadEvent(), ignored");
		LanguageCloseFile(tmpLangFileID);
		LanguageCloseFile(tmpNameFileID);
		return;
	}*/
// <-- KK
	bool makeCorpse = bCorpseMode==4 && CheckAttribute(chr,"corpse")==true;
	if(!makeCorpse) makeCorpse = CheckAttribute(chr,"corpse")==false;
	if(makeCorpse && bCorpseMode!=3) // do not generate a corpse from a corpse
	{
		bool GenerateCorpse = true;
		if(CheckAttribute(chr,"sex") && chr.sex == "monkey") GenerateCorpse = false; // No corpses for monkeys
		if(chr.name==LanguageConvertString(tmpNameFileID,"Crewmember") && bCorpseMode<4) GenerateCorpse = false; // No corpses for permanent crewmembers (Screwface) //MAXIMUS

	     //JRH -->
		if(CheckAttribute(chr,"location"))
		{
			if(chr.location == "wr_port")
			{
				chr.money = 0;
				TakenItems(chr, "gunpowder", -1);
				TakenItems(chr, "pistolbullets", -1);
			}

			if(chr.location == "Redmond_shipyard")
			{
				if(CheckAttribute(chr,"id") && chr.id == "wr_bochat")
				{
				 	chr.money = 30;
				}
				else chr.money = 0;
			}

			if(chr.location == "wr_shop")
			{
				if(CheckAttribute(chr,"id") && chr.id == "wr_oman1X")
				{
				 	chr.money = 30;
				}
				else chr.money = 0;
			}

			if(chr.location == "wr_wine_cellar") chr.money = 0;
			if(chr.location == "wr_ships" || chr.location == "wr_gall_captain" || chr.location == "wr_corv_capmd")
			ChangeCharacterAddressGroup(chr, "none", "", "");
		}
	    //<-- JRH

		if(CheckAttribute(chr,"chr_ai.type") && chr.chr_ai.type == "Building") GenerateCorpse = false; // No corpses for buildings (ccc building kit Jan06)
		if(LAi_IsBoardingProcess()==true && AUTOLOOT_BOARDINGS && bCorpseMode<4) GenerateCorpse = false; // PB: No corpses during boardings - Instead automatic looting (at LDH's request) //MAXIMUS: excludes player's decks
		if(bCorpseMode!=2 && bCorpseMode<4) GenerateCorpse = false; // TIH only corpsemode 2 makes a lootable corpse Sep2'06
		// LDH 27Sep06 added CheckAttribute
// changed by MAXIMUS 12.10.2006 -->
		if(bLoc)
		{
			if(CheckAttribute(lcn, "abbey") == true && sti(lcn.abbey) == true) GenerateCorpse = true; // TIH for maltese knight abbey // KK
		}
// changed by MAXIMUS 12.10.2006 <--
		if(bCorpseMode==4 && CheckAttribute(chr,"makelocator")) { DeleteAttribute(chr,"makelocator"); CharacterExitFromLocation(chr); GenerateCorpse = false; }//MAXIMUS: for captains cabin

		if(GenerateCorpse)
		{
			if(bCorpseMode!=4) { LAi_GenerateFantomFromMe(chr); }// NK do this here 05-07-13 //MAXIMUS
			// ccc Nov 05 Greater Oxbay create ghosts in Maltese Abbey
			ref corpse;
			int x, y, z;
			aref ito, ifrom;
			// TIH --> we make sure that no already looted items are transfered Sep2'06
			bool bPurgeLoot = false;
			string tempitm;

			if(CheckAttribute(chr,"model") && chr.model == "Animists3")
			{
				if(bCorpseMode==4) { LAi_GenerateFantomFromMe(chr); } //MAXIMUS
				x = stf(chr.deathx);
				y = stf(chr.deathy);
				z = stf(chr.deathz);

				CreateParticleSystemX("fire_medium", x, y+2, z, x, y+2, z,2);	// effects at that pos
				If(USE_PARTICLES>0) CreateParticleSystemX("seafoam", x, y+1.5, z, x, y+2, z,2);	// ccc Dec05 tweak added
				If(USE_PARTICLES>1) CreateParticleSystemX("artifact", x, y+1.5, z, x, y+2, z,2);	// ccc Dec05 tweak added

				LAi_CharacterPlaySound(chr, "OBJECTS\VOICES\DEAD\skeleton\skeleton_dead01.wav");
				PlayStereoSound("AMBIENT\INCA TEMPLE\teleporter.wav");
				If(USE_PARTICLES>0) PlayStereoSound("NATURE\wind_tornado.wav");	// ccc Dec05 tweak added
				logit(TranslateString("","The weird monk reveals his true nature.."));

				corpse = LAi_CreateFantomCharacterEx(false, 3, true, false, 0.0, "skel2", "man", "", "");
				GiveItem2Character(corpse, "blade8");
				EquipCharacterByItem(corpse, "blade8");
				LAi_SetWarriorType(corpse);
				LAi_group_MoveCharacter(corpse, LAI_GROUP_MONSTERS);
				LAi_group_SetRelation(LAI_GROUP_PLAYER, LAI_GROUP_MONSTERS, LAI_GROUP_ENEMY);
				corpse.name = LanguageConvertString(tmpNameFileID,"Maltese");
				corpse.lastname = LanguageConvertString(tmpNameFileID,"Knight");
				corpse.dialog.filename = "Maltese_corpse_dialog.c";
				corpse.humantype = "MalteseKnight";
				LAi_SetImmortal(corpse, false);
				if(bCorpseMode==4)
				{
					if(CheckAttribute(chr, "items"))
					{
						makearef(ifrom, chr.items);
						corpse.items = "";
						makearef(ito, corpse.items);
						CopyAttributes(&ito, &ifrom);
					}
					LAi_CharacterLogoff(chr);
					CharacterExitFromLocation(chr);

					TeleportCharacterToPosAY(corpse, stf(chr.deathx), stf(chr.deathy), stf(chr.deathz), stf(chr.deathay));
				}
			}
			else
			{
				// original corpsecreation
				if(bCorpseMode!=4)
				{
					corpse = LAi_CreateFantomCharacterEx(false, 0, false, false, 0.0, chr.model, chr.sex, "", "");
					corpse.corpse = true;
					LAi_SetImmortal(corpse, true);
					//corpse.lastname = GetMyFullName(chr);
					//corpse.name = XI_ConvertString("The late");
					LAi_SetStunnedTypeNoGroup(corpse);
					LAi_group_MoveCharacter(corpse, LAI_GROUP_CORPSES);
					corpse.dialog.filename = "Corpse_dialog.c";
					if(CheckAttribute(corpse,"humantype") && corpse.humantype=="MalteseKnight") corpse.dialog.filename = "Maltese_corpse_dialog.c";
					DeleteAttribute(corpse, "items");
					if(AUTOLOOT_ON) bPurgeLoot = true;
					if(bAbordageStarted && AUTOLOOT_BOARDINGS) bPurgeLoot = true;
					if(CheckAttribute(chr, "items"))
					{
						if(bPurgeLoot)
						{
							tempitm = "";
							tempitm = GetCharacterEquipByGroup(chr,BLADE_ITEM_TYPE);
							if (tempitm != "") TakeItemFromCharacter(chr, tempitm);
							tempitm = GetCharacterEquipByGroup(chr,GUN_ITEM_TYPE);
							if (tempitm != "") TakeItemFromCharacter(chr, tempitm);
						}
						makearef(ifrom, chr.items);
						corpse.items = "";
						makearef(ito, corpse.items);
						CopyAttributes(&ito, &ifrom);
					}
					TeleportCharacterToPosAY(corpse, stf(chr.deathx), stf(chr.deathy), stf(chr.deathz), stf(chr.deathay));
					if(CORPSE_AUTODISAPPEAR>0 && bCorpseMode!=1)//MAXIMUS: if(CORPSEMODE==1) - corpse must stay in location till player will leave this place
					{
						if(bCaptureShip==true) PostEvent("LAi_RemoveCorpse", 100, "i", corpse);
						else PostEvent("LAi_RemoveCorpse", CORPSE_AUTODISAPPEAR, "i", corpse);
					}
				}// NK added Friend, turned off genrank. 05-07-10//MAXIMUS
				else
				{
					corpse = CharacterFromId(chr.id);
					LAi_group_MoveCharacter(corpse, LAI_GROUP_CORPSES);
					//MAXIMUS: makes box from corpse with hand-icon in the top-left corner -->
					int locNum = 1;
					ref corpseLoc = &Locations[FindLocation(corpse.location)];
					if(CheckAttribute(corpseLoc,"locators.box"))
					{
						aref rootLocs; makearef(rootLocs, corpseLoc.locators.box);
						locNum = GetAttributesNum(rootLocs)+1;
					}
					string newLocName = "corpse_box"+locNum;
					WriteLocatorGlobal(chr.location, "box", newLocName, TranslateString("","body_of_"+chr.sex)+" "+GetMySimpleName(chr), sti(chr.index), stf(chr.deathx), stf(chr.deathy), stf(chr.deathz), true);
					//MAXIMUS: makes box from corpse with hand-icon in the top-left corner <--
				}// KK -->
				tempitm = GetCharacterEquipByGroup(corpse, BLADE_ITEM_TYPE);
				if (tempitm != "") corpse.old.blade = tempitm;
				tempitm = GetCharacterEquipByGroup(corpse, GUN_ITEM_TYPE);
				if (tempitm != "") corpse.old.gun = tempitm;// <-- KK
			}
			if(CheckAttribute(chr,"CORPSEMODE")) corpse.CORPSEMODE = chr.CORPSEMODE;
			if(bPurgeLoot) chr.money = 0;// TIH if already looted, make sure there is no money Sep2'06
			if(!CheckAttribute(chr,"money")) { chr.money = 0; }//MAXIMUS: for missed attribute
			corpse.money = chr.money;
			LAi_group_CheckGroupQuest(chr);
		}
	}
	LanguageCloseFile(tmpNameFileID);
// ccc jul05 corpse end
}

// added by MAXIMUS [corpses are automatic disappear from location] -->
#event_handler("LAi_RemoveCorpse", "LAi_CleanCorpses");
void LAi_CleanCorpses()
{
	aref corpse = GetEventData();
// LDH -->  Keeps corpses from disappearing while we're in a dialog which breaks the dialog and can kill a quest.
	if(CheckAttribute(GetMainCharacter(), "IsInDialog"))
	{
		if (CORPSE_AUTODISAPPEAR > 0)	// Defensive programming, in case logic is changed elsewhere
			PostEvent("LAi_RemoveCorpse", CORPSE_AUTODISAPPEAR, "i", corpse);
		else
			PostEvent("LAi_RemoveCorpse", 500, "i", corpse);
		return;
	}
// LDH <--
	if(CheckAttribute(corpse,"chr_ai.immortal"))) Lai_KillCharacter(corpse);
}
// added by MAXIMUS [corpses are automatic disappear from location] <--

#event_handler("LAi_event_GameOver", "LAi_GameOver");
void LAi_GameOver()
{
	string str = GetEventData();
	GameOver(str);
}



//==========================================================================================
//Internal events
//==========================================================================================

//------------------------------------------------------------------------------------------
//    
//------------------------------------------------------------------------------------------

void LAi_Character_TemplateComplite(aref chr, string tmplName)
{

	int index = sti(chr.index);
	PostEvent("LAi_event_Character_TemplateComplite", 1, "ls", index, tmplName);

}

#event_handler("LAi_event_Character_TemplateComplite", "LAi_Character_TemplateComplite_Event");
void LAi_Character_TemplateComplite_Event()
{
	int index = GetEventData();
	string tmpl = GetEventData();
	ref chr = &Characters[index];
	if (!CheckAttribute(chr, "chr_ai.type")) return;		// LDH - fix for missing chr 20AUG06 [MAXIMUS fix - was (chr, "chr_ai")]
	string func = chr.chr_ai.type;
	if(func != "")
	{
		func = "LAi_type_" + func + "_TemplateComplite";
		call func(chr, tmpl);
	}
}

//------------------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------------------

void LAi_Character_FreeLocator(aref chr, string group, string locator)
{
	int index = sti(chr.index);
	PostEvent("LAi_event_Character_FreePos", 1, "lss", index, group, locator);
}

#event_handler("LAi_event_Character_FreePos", "LAi_Character_FreePos_Event");
void LAi_Character_FreePos_Event()
{
	int index = GetEventData();
	string group = GetEventData();
	string locator = GetEventData();
	for(int i = 0; i < LAi_numloginedcharacters; i++)
	{
		int idx = LAi_loginedcharacters[i];
		if(idx >= 0)
		{
			if(idx != index)
			{
				float dist;
				if(GetCharacterDistByLoc(&Characters[idx], group, locator, dist))
				{
					if(dist < 0.8)
					{
						string func = Characters[idx].chr_ai.tmpl;
						if(func == "") return;
						//
						func = "LAi_tmpl_" + func + "_FreePos";
						call func(&Characters[idx], &Characters[index]);
					}
				}
			}
		}
	}
}


//------------------------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------------------

void LAi_Character_NeedDialog(aref chr, aref by)
{
	if(IsEntity(by))
	{
		string func = chr.chr_ai.type;
		if(func != "")
		{
			func = "LAi_type_" + func + "_NeedDialog";
			call func(by, chr);
		}
	}
}

//  ,   true       
bool LAi_Character_CanDialog(aref chr, aref by)
{
	if(IsEntity(by) && !CheckAttribute(by,"condition") && !CheckAttribute(chr,"condition"))//MAXIMUS: for skipping dialog with character during ChangeCharacterAddress
	{
		bool isDisable = false;
		if(CheckAttribute(chr, "chr_ai.disableDlg"))
		{
			if(sti(chr.chr_ai.disableDlg) != 0) isDisable = true;
		}
		if(isDisable == false)
		{
			string func = by.chr_ai.type;
			if(func != "")
			{
				func = "LAi_type_" + func + "_CanDialog";
				return call func(by, chr);
			}
		}
	}
	return false;
}

// 
void LAi_Character_StartDialog(aref chr, aref by)
{
	if(IsEntity(by))
	{
		string func = by.chr_ai.type;
		if(func != "")
		{
			func = "LAi_type_" + func + "_StartDialog";
			call func(by, chr);
		}
	}
}

// 
void LAi_Character_EndDialog(aref chr, aref by)
{
	if(IsEntity(by))
	{
		string func = by.chr_ai.type;
		if(func != "")
		{
			func = "LAi_type_" + func + "_EndDialog";
			call func(by, chr);
		}
	}
}
bool LAi_DoCORPEMODE(aref chr)
{
		if (CheckAttribute(chr, "corpse")) return true;
		if (bAbordageStarted) return true;
		if (chr.name==XI_ConvertString("Crewmember")) return true;
		if (chr.name=="Pirate") return true;
		if (chr.name+chr.lastname=="Bernardo"+"Gamboa") return true;
		if (chr.name+chr.lastname=="Nigel"+"Blythe") return true;
		if (chr.name+chr.lastname=="Artois"+"Voysey") return true;
		if (chr.chr_ai.group=="FBQ_SPAIN_SOLDIERS") return true;
		if (chr.name=="French Soldier") return true;
		if (chr.chr_ai.group=="ENGLAND_TAVERN_SOLDIERS") return true;
		if (chr.chr_ai.group=="SMUGGLERS_SOLDIERS") return true;
		if (chr.chr_ai.group=="ACTOR") return true;
		if (chr.chr_ai.group=="GREENFORD_MURDERERS") return true;
		return false;
}
